object DataModule1: TDataModule1
  OldCreateOrder = False
  Left = 229
  Top = 338
  Height = 205
  Width = 666
  object TClientes: TTable
    Active = True
    AfterPost = TClientesAfterPost
    AfterDelete = TClientesAfterDelete
    DatabaseName = 'Locadora'
    TableName = 'Clientes.DB'
    Left = 24
    Top = 16
    object TClientesCliCodigo: TIntegerField
      Alignment = taCenter
      FieldName = 'CliCodigo'
    end
    object TClientesCliNome: TStringField
      FieldName = 'CliNome'
      Size = 45
    end
    object TClientesCliRG: TStringField
      FieldName = 'CliRG'
      Size = 15
    end
    object TClientesCliCPF: TStringField
      FieldName = 'CliCPF'
      Size = 15
    end
    object TClientesCliEndereco: TStringField
      FieldName = 'CliEndereco'
      Size = 60
    end
    object TClientesCliCidade: TStringField
      FieldName = 'CliCidade'
      Size = 40
    end
    object TClientesCliCEP: TStringField
      FieldName = 'CliCEP'
      EditMask = '00000\-9999;1;_'
      Size = 15
    end
    object TClientesCliTelefone: TStringField
      FieldName = 'CliTelefone'
      EditMask = '!\(999\)0000-0000;1;_'
    end
    object TClientesCliDataAdesao: TDateField
      FieldName = 'CliDataAdesao'
      EditMask = '!99/99/0000;1;_'
    end
    object TClientesCliEmail: TStringField
      FieldName = 'CliEmail'
      Size = 50
    end
    object TClientesBloqueado: TBooleanField
      FieldName = 'Bloqueado'
    end
    object TClientesCliFoto: TGraphicField
      FieldName = 'CliFoto'
      BlobType = ftGraphic
    end
    object TClientesCliDataNascimento: TDateField
      FieldName = 'CliDataNascimento'
      EditMask = '!99/99/9999;1;_'
    end
    object TClientesCliSaldo: TCurrencyField
      FieldName = 'CliSaldo'
    end
    object TClientesCliComplemento: TStringField
      FieldName = 'CliComplemento'
      Size = 30
    end
    object TClientesCliNumero: TStringField
      FieldName = 'CliNumero'
      Size = 5
    end
    object TClientesCliBairro: TStringField
      FieldName = 'CliBairro'
      Size = 30
    end
  end
  object DSClientes: TDataSource
    DataSet = TClientes
    Left = 24
    Top = 64
  end
  object TFilmes: TTable
    Active = True
    AfterPost = TFilmesAfterPost
    AfterDelete = TFilmesAfterDelete
    DatabaseName = 'Locadora'
    TableName = 'Filmes.db'
    Left = 80
    Top = 16
    object TFilmesFilCodigo: TIntegerField
      Alignment = taCenter
      FieldName = 'FilCodigo'
    end
    object TFilmesFilTitulo: TStringField
      FieldName = 'FilTitulo'
      Size = 45
    end
    object TFilmesFilOriginal: TStringField
      FieldName = 'FilOriginal'
      Size = 45
    end
    object TFilmesFilAtores: TStringField
      FieldName = 'FilAtores'
      Size = 45
    end
    object TFilmesFilDiretor: TStringField
      FieldName = 'FilDiretor'
      Size = 35
    end
    object TFilmesFilPais: TStringField
      FieldName = 'FilPais'
      Size = 25
    end
    object TFilmesFilAno: TIntegerField
      FieldName = 'FilAno'
    end
    object TFilmesFilDuracao: TStringField
      FieldName = 'FilDuracao'
      EditMask = '00\:00;1;_'
      Size = 5
    end
    object TFilmesFilAquisicao: TDateField
      FieldName = 'FilAquisicao'
      EditMask = '!00/00/0000;1;_'
    end
    object TFilmesFilGenero: TIntegerField
      FieldName = 'FilGenero'
    end
    object TFilmesFilDistribuidor: TIntegerField
      FieldName = 'FilDistribuidor'
    end
    object TFilmesFilCategoria: TIntegerField
      FieldName = 'FilCategoria'
    end
    object TFilmesFilValorAquisicao: TCurrencyField
      FieldName = 'FilValorAquisicao'
    end
    object TFilmesFilValorCategoria: TCurrencyField
      FieldName = 'FilValorCategoria'
    end
    object TFilmesCatDescr: TStringField
      FieldKind = fkLookup
      FieldName = 'CatDescr'
      LookupDataSet = TCategoria
      LookupKeyFields = 'CatCodigo'
      LookupResultField = 'CatDescricao'
      KeyFields = 'FilCategoria'
      Size = 25
      Lookup = True
    end
    object TFilmesGenDesci: TStringField
      FieldKind = fkLookup
      FieldName = 'GenDesci'
      LookupDataSet = TGenero
      LookupKeyFields = 'GenCodigo'
      LookupResultField = 'GenDescricao'
      KeyFields = 'FilGenero'
      Size = 25
      Lookup = True
    end
    object TFilmesFilAlugado: TStringField
      FieldName = 'FilAlugado'
      Size = 3
    end
    object TFilmesFilMidia: TStringField
      FieldName = 'FilMidia'
      Size = 3
    end
    object TFilmesFilMR: TIntegerField
      FieldName = 'FilMR'
    end
    object TFilmesFilLegenda: TStringField
      FieldName = 'FilLegenda'
      Size = 10
    end
    object TFilmesDistribuidor: TStringField
      FieldKind = fkLookup
      FieldName = 'Distribuidor'
      LookupDataSet = TDistribuidor
      LookupKeyFields = 'DisCodigo'
      LookupResultField = 'DisDescricao'
      KeyFields = 'FilDistribuidor'
      Size = 45
      Lookup = True
    end
  end
  object DSFilmes: TDataSource
    DataSet = TFilmes
    Left = 80
    Top = 64
  end
  object TUsuario: TTable
    Active = True
    AfterPost = TUsuarioAfterPost
    AfterDelete = TUsuarioAfterDelete
    DatabaseName = 'Locadora'
    TableName = 'Usuarios.db'
    Left = 144
    Top = 16
    object TUsuarioUsuCodigo: TIntegerField
      Alignment = taCenter
      FieldName = 'UsuCodigo'
    end
    object TUsuarioUsuNome: TStringField
      FieldName = 'UsuNome'
      Size = 45
    end
    object TUsuarioUsuCPF: TStringField
      FieldName = 'UsuCPF'
    end
    object TUsuarioUsuRG: TStringField
      FieldName = 'UsuRG'
    end
    object TUsuarioUsuAdmissao: TDateField
      FieldName = 'UsuAdmissao'
      EditMask = '!00/00/0000;1;_'
    end
    object TUsuarioUsuEndereco: TStringField
      FieldName = 'UsuEndereco'
      Size = 50
    end
    object TUsuarioUsuCidade: TStringField
      FieldName = 'UsuCidade'
      Size = 35
    end
    object TUsuarioUsuCEP: TStringField
      FieldName = 'UsuCEP'
      Size = 15
    end
    object TUsuarioUsuTelefone: TStringField
      FieldName = 'UsuTelefone'
    end
    object TUsuarioNick: TStringField
      FieldName = 'Nick'
      Size = 25
    end
    object TUsuarioSenha: TStringField
      FieldName = 'Senha'
      Size = 15
    end
    object TUsuarioAutMovBD: TBooleanField
      FieldName = 'AutMovBD'
    end
    object TUsuarioAutRelSC: TBooleanField
      FieldName = 'AutRelSC'
    end
    object TUsuarioAutUsu: TBooleanField
      FieldName = 'AutUsu'
    end
    object TUsuarioAutCli: TBooleanField
      FieldName = 'AutCli'
    end
    object TUsuarioAutFil: TBooleanField
      FieldName = 'AutFil'
    end
    object TUsuarioAutConC: TBooleanField
      FieldName = 'AutConC'
    end
  end
  object DSUsuario: TDataSource
    DataSet = TUsuario
    Left = 144
    Top = 64
  end
  object TAutorizados: TTable
    Active = True
    AfterPost = TAutorizadosAfterPost
    AfterDelete = TAutorizadosAfterDelete
    DatabaseName = 'Locadora'
    TableName = 'Autorizados.db'
    Left = 216
    Top = 16
    object TAutorizadosRegistro: TAutoIncField
      FieldName = 'Registro'
      ReadOnly = True
    end
    object TAutorizadosAutCliCodigo: TIntegerField
      Alignment = taCenter
      FieldName = 'AutCliCodigo'
    end
    object TAutorizadosAutNome: TStringField
      FieldName = 'AutNome'
      Size = 45
    end
    object TAutorizadosAutRG: TStringField
      FieldName = 'AutRG'
    end
    object TAutorizadosAutCPF: TStringField
      FieldName = 'AutCPF'
    end
    object TAutorizadosAutDataNascimento: TDateField
      FieldName = 'AutDataNascimento'
      EditMask = '!99/99/9999;1;_'
    end
    object TAutorizadosAutFoto: TGraphicField
      FieldName = 'AutFoto'
      BlobType = ftGraphic
    end
    object TAutorizadosAutParentesco: TStringField
      FieldName = 'AutParentesco'
      Size = 25
    end
    object TAutorizadosCliNome: TStringField
      FieldKind = fkLookup
      FieldName = 'CliNome'
      LookupDataSet = TClientes
      LookupKeyFields = 'CliCodigo'
      LookupResultField = 'CliNome'
      KeyFields = 'AutCliCodigo'
      Size = 25
      Lookup = True
    end
  end
  object DSAutorizados: TDataSource
    DataSet = TAutorizados
    Left = 216
    Top = 64
  end
  object TGenero: TTable
    Active = True
    AfterPost = TGeneroAfterPost
    AfterDelete = TGeneroAfterDelete
    DatabaseName = 'Locadora'
    TableName = 'Genero.db'
    Left = 288
    Top = 16
    object TGeneroGenCodigo: TIntegerField
      Alignment = taCenter
      FieldName = 'GenCodigo'
    end
    object TGeneroGenDescricao: TStringField
      FieldName = 'GenDescricao'
      Size = 35
    end
    object TGeneroCenIdade: TIntegerField
      DisplayWidth = 3
      FieldName = 'CenIdade'
    end
    object TGeneroGenCensura: TBooleanField
      FieldName = 'GenCensura'
    end
  end
  object DSGenero: TDataSource
    DataSet = TGenero
    Left = 288
    Top = 64
  end
  object TDistribuidor: TTable
    Active = True
    AfterPost = TDistribuidorAfterPost
    AfterDelete = TDistribuidorAfterDelete
    DatabaseName = 'Locadora'
    TableName = 'Distribuidor.db'
    Left = 352
    Top = 16
    object TDistribuidorDisCodigo: TIntegerField
      Alignment = taCenter
      FieldName = 'DisCodigo'
    end
    object TDistribuidorDisDescricao: TStringField
      FieldName = 'DisDescricao'
      Size = 35
    end
    object TDistribuidorDisEndereco: TStringField
      FieldName = 'DisEndereco'
      Size = 45
    end
    object TDistribuidorDisTelefone: TStringField
      FieldName = 'DisTelefone'
      EditMask = '!\(999\)0000-0000;1;_'
    end
    object TDistribuidorDisEmail: TStringField
      FieldName = 'DisEmail'
      Size = 35
    end
  end
  object DSDistribuidor: TDataSource
    DataSet = TDistribuidor
    Left = 352
    Top = 64
  end
  object TCategoria: TTable
    Active = True
    AfterPost = TCategoriaAfterPost
    AfterDelete = TCategoriaAfterDelete
    DatabaseName = 'Locadora'
    TableName = 'Categoria.DB'
    Left = 424
    Top = 16
    object TCategoriaCatCodigo: TIntegerField
      Alignment = taCenter
      FieldName = 'CatCodigo'
    end
    object TCategoriaCatValor: TCurrencyField
      FieldName = 'CatValor'
    end
    object TCategoriaCatDescricao: TStringField
      FieldName = 'CatDescricao'
      Size = 25
    end
  end
  object DSCategoria: TDataSource
    DataSet = TCategoria
    Left = 424
    Top = 64
  end
  object TMovimento: TTable
    Active = True
    AfterPost = TMovimentoAfterPost
    AfterDelete = TMovimentoAfterDelete
    DatabaseName = 'Locadora'
    TableName = 'Movimento.db'
    Left = 496
    Top = 16
    object TMovimentoRegistro: TAutoIncField
      FieldName = 'Registro'
      ReadOnly = True
    end
    object TMovimentoMovDataLocacao: TDateField
      FieldName = 'MovDataLocacao'
    end
    object TMovimentoMovFormaPag: TStringField
      FieldName = 'MovFormaPag'
    end
    object TMovimentoMovTotal: TCurrencyField
      FieldName = 'MovTotal'
    end
    object TMovimentoMovValorDebito: TCurrencyField
      FieldName = 'MovValorDebito'
    end
    object TMovimentoMovDebito: TBooleanField
      Alignment = taCenter
      FieldName = 'MovDebito'
    end
    object TMovimentoMovCliente: TIntegerField
      Alignment = taCenter
      FieldName = 'MovCliente'
    end
    object TMovimentoClienteNome: TStringField
      FieldKind = fkLookup
      FieldName = 'ClienteNome'
      LookupDataSet = TClientes
      LookupKeyFields = 'CliCodigo'
      LookupResultField = 'CliNome'
      KeyFields = 'MovCliente'
      Size = 45
      Lookup = True
    end
    object TMovimentoMovEAut: TBooleanField
      FieldName = 'MovEAut'
    end
    object TMovimentoMovAutNome: TStringField
      FieldName = 'MovAutNome'
      Size = 45
    end
    object TMovimentoHoralocacao: TTimeField
      FieldName = 'Horalocacao'
    end
    object TMovimentoMovPag: TStringField
      FieldName = 'MovPag'
      Size = 15
    end
    object TMovimentoMovDataDevolucao: TDateField
      FieldName = 'MovDataDevolucao'
    end
    object TMovimentoDataDR: TDateField
      FieldName = 'DataDR'
    end
    object TMovimentoCliNome: TStringField
      FieldKind = fkLookup
      FieldName = 'CliNome'
      LookupDataSet = TClientes
      LookupKeyFields = 'CliCodigo'
      LookupResultField = 'CliNome'
      KeyFields = 'MovCliente'
      Size = 45
      Lookup = True
    end
  end
  object DSMovimento: TDataSource
    DataSet = TMovimento
    Left = 496
    Top = 64
  end
  object TLancamento: TTable
    Active = True
    AfterPost = TLancamentoAfterPost
    AfterDelete = TLancamentoAfterDelete
    DatabaseName = 'Locadora'
    MasterSource = DSMovimento
    TableName = 'Lancamento.DB'
    Left = 576
    Top = 16
    object TLancamentoRegistro: TAutoIncField
      FieldName = 'Registro'
      ReadOnly = True
    end
    object TLancamentoLMovRegistro: TIntegerField
      FieldName = 'LMovRegistro'
    end
    object TLancamentoLFilme: TIntegerField
      Alignment = taCenter
      FieldName = 'LFilme'
    end
    object TLancamentoTitulo: TStringField
      FieldKind = fkLookup
      FieldName = 'Titulo'
      LookupDataSet = TFilmes
      LookupKeyFields = 'FilCodigo'
      LookupResultField = 'FilTitulo'
      KeyFields = 'LFilme'
      Size = 35
      Lookup = True
    end
    object TLancamentoValoCategoria: TFloatField
      Alignment = taCenter
      FieldKind = fkLookup
      FieldName = 'ValoCategoria'
      LookupDataSet = TFilmes
      LookupKeyFields = 'FilCodigo'
      LookupResultField = 'FilValorCategoria'
      KeyFields = 'LFilme'
      currency = True
      Lookup = True
    end
    object TLancamentoLDataDevolucao: TDateField
      FieldName = 'LDataDevolucao'
    end
    object TLancamentoLHoraDevolucao: TTimeField
      FieldName = 'LHoraDevolucao'
    end
    object TLancamentoLDevolvido: TStringField
      FieldName = 'LDevolvido'
      Size = 3
    end
    object TLancamentoLCliente: TIntegerField
      FieldName = 'LCliente'
    end
    object TLancamentoLEAut: TBooleanField
      FieldName = 'LEAut'
    end
    object TLancamentoLAutNome: TStringField
      FieldName = 'LAutNome'
      Size = 35
    end
    object TLancamentoLDataLocacao: TDateField
      Alignment = taCenter
      FieldName = 'LDataLocacao'
    end
    object TLancamentoLHoraLocacao: TTimeField
      Alignment = taCenter
      FieldName = 'LHoraLocacao'
    end
    object TLancamentoLFormaPag: TStringField
      FieldName = 'LFormaPag'
    end
    object TLancamentoLPag: TStringField
      FieldName = 'LPag'
      Size = 3
    end
    object TLancamentoCliente: TStringField
      FieldKind = fkLookup
      FieldName = 'Cliente'
      LookupDataSet = TClientes
      LookupKeyFields = 'CliCodigo'
      LookupResultField = 'CliNome'
      KeyFields = 'LCliente'
      Size = 45
      Lookup = True
    end
    object TLancamentoLDataDR: TDateField
      FieldName = 'LDataDR'
    end
    object TLancamentoCliNome: TStringField
      FieldKind = fkLookup
      FieldName = 'CliNome'
      LookupDataSet = TClientes
      LookupKeyFields = 'CliCodigo'
      LookupResultField = 'CliNome'
      KeyFields = 'LCliente'
      Size = 45
      Lookup = True
    end
    object TLancamentoLUsuario: TStringField
      FieldName = 'LUsuario'
      Size = 45
    end
    object TLancamentoLPreco: TCurrencyField
      FieldName = 'LPreco'
    end
    object TLancamentoCupom: TStringField
      FieldName = 'Cupom'
      Size = 3
    end
  end
  object DSLancamento: TDataSource
    DataSet = TLancamento
    Left = 576
    Top = 64
  end
  object TCaixa: TTable
    Active = True
    AfterPost = TCaixaAfterPost
    AfterDelete = TCaixaAfterDelete
    DatabaseName = 'Locadora'
    IndexFieldNames = 'Data'
    TableName = 'Caixa.db'
    Left = 24
    Top = 128
    object TCaixaData: TDateField
      FieldName = 'Data'
    end
    object TCaixaSaldoInicial: TCurrencyField
      FieldName = 'SaldoInicial'
    end
    object TCaixaTroco: TCurrencyField
      FieldName = 'Troco'
    end
    object TCaixaEntrada: TCurrencyField
      FieldName = 'Entrada'
    end
    object TCaixaSaldoFinal: TCurrencyField
      FieldName = 'SaldoFinal'
    end
  end
  object DSCaixa: TDataSource
    DataSet = TCaixa
    Left = 24
    Top = 176
  end
end
