unit u_DTodos;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, SuperEdit, Grids, DBGrids, ComCtrls,DateUtils,
  ExtCtrls, DBTables;

type
  TFDTodos = class(TForm)
    DBGrid1: TDBGrid;
    g: TGroupBox;
    BitBtn2: TBitBtn;
    L1: TLabel;
    multa: TEdit;
    cobrar: TButton;
    lsaldo: TLabel;
    saldo: TEdit;
    debito: TEdit;
    a7: TLabel;
    a1: TComboBox;
    a2: TLabel;
    credito: TEdit;
    troco: TEdit;
    a4: TLabel;
    Label8: TLabel;
    total: TEdit;
    Valores: TBitBtn;
    Bevel3: TBevel;
    Bevel2: TBevel;
    Bevel1: TBevel;
    Bevel6: TBevel;
    Bevel9: TBevel;
    Bevel10: TBevel;
    Cliente: TSuperEdit;
    Label1: TLabel;
    SpeedButton1: TSpeedButton;
    Label2: TLabel;
    nome: TSuperEdit;
    BitBtn3: TBitBtn;
    Label3: TLabel;
    DataD: TDateTimePicker;
    SpeedButton2: TSpeedButton;
    filme: TSuperEdit;
    Label6: TLabel;
    Label5: TLabel;
    Label4: TLabel;
    DebitoC: TEdit;
    SaldoC: TEdit;
    Bevel4: TBevel;
    procedure FormShow(Sender: TObject);
    procedure cobrarClick(Sender: TObject);
    procedure ValoresClick(Sender: TObject);
    procedure creditoKeyPress(Sender: TObject; var Key: Char);
    procedure BitBtn2Click(Sender: TObject);
    procedure DataDChange(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure ClienteKeyPress(Sender: TObject; var Key: Char);
    procedure filmeKeyPress(Sender: TObject; var Key: Char);
    procedure DBGrid1DblClick(Sender: TObject);
  private
    { Private declarations }
    function valormulta:real;
    procedure tirasaldo;
    procedure zera;
    procedure alimenta;
  public
    { Public declarations }
  end;

var
  FDTodos: TFDTodos;
  SaldoI,pag,registro,dev : String;
  TotalI,DebitoI : Real;
  regdebito,cli : integer;

implementation

uses u_DM, u_MLocacao;


{$R *.dfm}



procedure TFDTodos.alimenta;

procedure soma;
begin
  totali := 0;
  with DataModule1.TLancamento do
  begin
     first;
     while not eof do
     begin
        if FieldByName('LPag').asString = 'DEV' then
           totali := totali + FieldByName('LPreco').AsFloat;
     next;
     end;
  end;
end;

function calculadebitos : real;
begin
  DataModule1.TMovimento.IndexName := 'MovCliente';
  if DataModule1.TMovimento.FindKey([StrToInt(cliente.text)]) then
  result := DataModule1.TMovimento.FieldByName('MovValorDebito').AsFloat;
end;


var deb,multas:real;
    x:integer;

begin

deb := 0;
if Trim(cliente.text)<>'' then
begin

// filtrando tabela para cliente
FDTodos.cursor := crHourGlass;
DataModule1.TLancamento.Filtered := False;
DataModule1.TLancamento.Filter := 'LMovRegistro = ' + registro +
  ' And LDevolvido= ' + '''' + 'No'+ '''';
DataModule1.TLancamento.Filtered := True;
FDTodos.cursor := crDeFault;
end;

//verificando se a tabela nao esta vazia
if DataModule1.TLancamento.RecordCount > 0 then
begin

{DataModule1.TLancamento.Last;
regdebito := DataModule1.TLancamento.FieldByName('LMovRegistro').AsInteger;
pag :=DataModule1.TLancamento.FieldByName('LPag').AsString;

//calcula debitos
 with DataModule1.TMovimento do
 begin
   if pag = 'DEV' then
   begin
     FindKey([regdebito]);
     deb := FieldByName('MovValorDebito').AsFloat;
   end else deb := 0;
 end;}

// aliemtando variaveis e captions
 Saldo.Text := FMovimento.FloatStr(FloatToStr(DataModule1.TClientes.FieldByName('CliSaldo').AsFloat));
 SaldoC.Text := FMovimento.FloatStr(FloatToStr(DataModule1.TClientes.FieldByName('CliSaldo').AsFloat));
 debito.text := FMovimento.FloatStr(FloatToStr(calculadebitos));
 DebitoC.Text := FMovimento.FloatStr(FloatToStr(calculadebitos));
 SaldoI := Saldo.Text;
 soma;
 Total.Text := FMovimento.FloatStr(FloatToStr(TotalI));
 DebitoI := StrToFloat(Debito.Text);
 multa.text := FMovimento.FloatStr(FloattoStr(valormulta));
 tirasaldo;
 DataModule1.TLancamento.IndexName := 'LDataLocacao';
 if (Totali>0) or (valormulta>0) then g.Height:=180
 else g.Height := 55;
end
else begin
 zera;
 g.Height := 55;
end;
end;


procedure TFDTodos.TiraSaldo;
var tot,cred : real;
begin
  if StrToFloat(SaldoI) >= StrToFloat(total.Text) then
  begin
    x := (StrToFLoat(Saldo.text) - StrtoFloat(total.text));
    credito.Text := FMovimento.FloatStr(FloatToStr(x));
    Saldo.Text := FMovimento.FloatStr(FloatToStr(x));
    LSaldo.Font.Color := clRed;
    tot := StrToFloat(total.Text);
    cred := StrToFloat(credito.Text);
    troco.Text := FMovimento.FloatStr(FloatToStr(cred-tot));
    debito.Text := FMovimento.FloatStr(FloatToStr(tot-cred));
  end;

  if StrToFloat(SaldoI) = StrToFloat(total.Text) then
  begin
   credito.Text := Saldo.Text;
   Saldo.Text := '0,00';
   tot := StrToFloat(total.Text);
   cred := StrToFloat(credito.Text);
   troco.Text := FMovimento.FloatStr(FloatToStr(cred-tot));
   debito.Text := FMovimento.FloatStr(FloatToStr(tot-cred));
  end;

  if (StrToFloat(SaldoI) < StrToFloat(total.Text)) and (StrToFloat(SaldoI)>0)then
  begin
  credito.Text := FMovimento.FloatStr(FloatToStr(StrToFloat(total.Text) - StrToFloat(Saldo.Text)));
  Saldo.Text := '0,00';
  end;
end;


procedure TFDTodos.zera;
begin
DataModule1.TLancamento.Filtered := False;
DataModule1.TLancamento.Filter := 'LCliente = 0 And LDevolvido = ' + '''' + 'No'+ '''';
DataModule1.TLancamento.Filtered := True;
cliente.text := '';
nome.text := '';
filme.text := '';
multa.text := '0,00';
saldo.text := '0,00';
saldoc.text := '0,00';
credito.text := '0,00';
troco.text := '0,00';
total.text := '0,00';
debitoc.text := '0,00';
SaldoI := '0';
DebitoI := 0;
Totali := 0;
end;

function TFDTodos.valormulta : real;
var
  x : integer;
  data : TDateTime;
begin
  result := 0;
  DataModule1.TLancamento.First;
  while not DataModule1.TLancamento.eof do
  begin
  if DataD.Date > DataModule1.TLancamento.FieldByName('LDataDevolucao').AsDateTime then
  begin
    x := 0;
    data := DataModule1.TLancamento.FieldByName('LDataDevolucao').AsDateTime;
    data := IncDay(Data,1);
    while data <= DataD.Date do
    begin
     data := IncDay(Data,1);
     x:= x + 1;
    end;
    result := result + (x * DataModule1.TLancamento.FieldByName('ValoCategoria').AsFloat);
  end;
  DataModule1.TLancamento.Next;
  end;
end;


procedure TFDTodos.FormShow(Sender: TObject);
begin
pag := 'T';
DataModule1.TLancamento.Filtered := False;
cliente.setfocus;
datad.date := date;
zera;
g.Height := 55;
end;

procedure TFDTodos.cobrarClick(Sender: TObject);
begin
total.text := FMovimento.FloatStr(FloatToStr(StrToFloat(total.text) + StrToFloat(multa.Text)));
Saldo.Text := SaldoI;
tirasaldo;
credito.setfocus;
end;

procedure TFDTodos.ValoresClick(Sender: TObject);
begin
Saldo.Text := FMovimento.FloatStr(FloatToStr(DataModule1.TClientes.FieldByName('CliSaldo').asFloat));
Saldoi := Saldo.Text;
Total.Text := FMovimento.FloatStr(FloatToStr(TotalI));
Debito.Text := FMovimento.FloatStr(FloatToStr(DebitoI));
tirasaldo;
troco.text := '0,00';
end;

procedure TFDTodos.creditoKeyPress(Sender: TObject; var Key: Char);
var tot,cred : real;
begin
if (key in ['a'..'z']) and (key in ['A'..'Z']) then key := #0;
if key = #13 then
begin
  if Trim(credito.Text)<>'' then begin
    tot := StrToFloat(total.Text);
    cred := StrToFloat(credito.Text);
    if (cred >=tot)then begin
      troco.Text := FMovimento.FloatStr(FloatToStr(cred-tot));
      debito.Text := FMovimento.FloatStr(FloatToStr(DebitoI));
    end;
    if (cred >= 0) and (cred <tot) then debito.Text := FMovimento.FloatStr(FloatToStr((debitoi)+(tot-cred)));
    tot := StrToFloat(DEBITO.Text);
    cred:= StrToFloat(troco.Text); //TROCO
    if (cred > 0) and (cred >=tot)then begin
      troco.Text := FMovimento.FloatStr(FloatToStr(cred-tot)); // troco
      debito.Text := '0,00';
    end;
    if (cred >= 0) and (cred < tot) then  begin
      Debito.Text := FMovimento.FloatStr(FloatToStr(StrToFloat(debito.text)-cred)); //DEBITO
      troco.Text := '0,00';
    end;
  end;
end;
end;

procedure TFDTodos.BitBtn2Click(Sender: TObject);

procedure encerra;
var
x :integer;
begin
if (DataModule1.TLancamento.RecordCount > 0) and (pag = 'T') then
begin


// devolvendo filmes
with DataModule1.TLancamento do
begin
  DataModule1.TFilmes.IndexFieldNames := 'FilCodigo';

  first;
  for x:= 1 to recordcount do
  begin
   DataModule1.TFilmes.FindKey([FieldByName('LFilme').asInteger]);
   DataModule1.TFilmes.Edit;
   DataModule1.TFilmes.FieldByName('FilAlugado').asString := 'No';
   DataModule1.TFilmes.FieldByName('FilMR').value := null;
   DataModule1.TFilmes.Post;
   edit;
   FieldByName('LDataDR').AsDateTime := DataD.Date;
   FieldByName('LDevolvido').asString := 'Sim';
   FieldByName('LHoraDevolucao').AsDateTime := Time;
   post;
   next;
  end;

  if StrtoFloat(Total.text) > 0 then
  begin
    DataModule1.TCaixa.FindKey([Date]);
    DataModule1.TCaixa.Edit;
    DataModule1.TCaixa.FieldByName('Troco').asFloat := DataModule1.TCaixa.FieldByName('Troco').asFloat +
      StrToFloat(troco.Text);
    DataModule1.TCaixa.FieldByName('Entrada').asFloat := DataModule1.TCaixa.FieldByName('Entrada').asFloat +
      StrToFloat(credito.Text);
    DataModule1.TCaixa.FieldByName('SaldoFinal').asFloat := DataModule1.TCaixa.FieldByName('SaldoInicial').asFloat +
      (DataModule1.TCaixa.FieldByName('Entrada').asFloat -
       DataModule1.TCaixa.FieldByName('Troco').asFloat);

     DataModule1.TCaixa.Post;
   end;
   // salvando debito
   if g.Height=180 then
   begin
      DataModule1.TMovimento.IndexFieldNames := 'Registro';
      DataModule1.TMovimento.FindKey([StrToInt(registro)]);
       DataModule1.TMovimento.Edit;
      if StrToFloat(debito.text)> 0 then DataModule1.TMovimento.FieldByName('MovDebito').asBoolean := True
      else DataModule1.TMovimento.FieldByName('MovDebito').asBoolean := False;
      DataModule1.TMovimento.FieldByName('MovValorDebito').asFloat := StrToFloat(debito.text);
      DataModule1.TMovimento.Post;
   end;
   ShowMessage('DEVOLUO COM SUCESSO !');
   zera;
   g.Height := 55;
end; // with Lancamento
end; // pag todos

// DEVOLUCAO INDIVIDUAL //

if (DataModule1.TLancamento.RecordCount > 0) and (pag = 'I') then
begin

// devolvendo filme
with DataModule1.TLancamento do
begin

   // Devolvendo filme na tabela de filmes
   DataModule1.TFilmes.IndexFieldNames := 'FilCodigo';
   DataModule1.TFilmes.FindKey([FieldByName('LFilme').asInteger]);
   DataModule1.TFilmes.Edit;
   DataModule1.TFilmes.FieldByName('FilAlugado').asString := 'No';
   DataModule1.TFilmes.FieldByName('FilMR').value := null;
   DataModule1.TFilmes.Post;

   // Devolvendo filme na tabela de lancamentos
   edit;
   FieldByName('LDataDR').AsDateTime := DataD.Date;
   FieldByName('LDevolvido').asString := 'Sim';
   FieldByName('LHoraDevolucao').AsDateTime := Time;
   post;

   //Salvando dados na tabela caixa
  if StrtoFloat(Total.text) > 0 then
  begin
    DataModule1.TCaixa.FindKey([DataD.Date]);
    DataModule1.TCaixa.Edit;
    DataModule1.TCaixa.FieldByName('Troco').asFloat := DataModule1.TCaixa.FieldByName('Troco').asFloat +
      StrToFloat(troco.Text);
    DataModule1.TCaixa.FieldByName('Entrada').asFloat := DataModule1.TCaixa.FieldByName('Entrada').asFloat +
      StrToFloat(credito.Text);
    DataModule1.TCaixa.FieldByName('SaldoFinal').asFloat := DataModule1.TCaixa.FieldByName('SaldoInicial').asFloat +
      (DataModule1.TCaixa.FieldByName('Entrada').asFloat -
       DataModule1.TCaixa.FieldByName('Troco').asFloat);

     DataModule1.TCaixa.Post;
   end;
  // salvando debito
  if g.Height=180 then
  begin
    DataModule1.TMovimento.IndexFieldNames := 'Registro';
    DataModule1.TMovimento.FindKey([StrToInt(registro)]);
    DataModule1.TMovimento.Edit;
    if StrToFloat(debito.text)> 0 then DataModule1.TMovimento.FieldByName('MovDebito').asBoolean := True
    else DataModule1.TMovimento.FieldByName('MovDebito').asBoolean := False;
    DataModule1.TMovimento.FieldByName('MovValorDebito').asFloat := StrToFloat(debito.text);
    DataModule1.TMovimento.Post;
  end;
   ShowMessage('DEVOLUO COM SUCESSO !');
   alimenta;
   credito.text := '0,00';
   troco.text := '0,00';

end; // PAGAMENTO INDIVIDUAL
end;

end;


var
tot,cred : real;
x :integer;
diferenca : string;
z:integer;

begin
z:=0;
// atualizando valores
if Trim(credito.Text)='0,00' then begin
  Saldo.Text := FMovimento.FloatStr(FloatToStr(DataModule1.TClientes.FieldByName('CliSaldo').asFloat));
  Saldoi := Saldo.Text;
  Total.Text := FMovimento.FloatStr(FloatToStr(TotalI));
  Debito.Text := FMovimento.FloatStr(FloatToStr(DebitoI));
  tirasaldo;
  troco.text := '0,00';
  tot := StrToFloat(total.Text);
  cred := StrToFloat(credito.Text);
  if Trim(credito.Text)<>'' then begin
    tot := StrToFloat(total.Text);
    cred := StrToFloat(credito.Text);
    if (cred >=tot)then begin
      troco.Text := FMovimento.FloatStr(FloatToStr(cred-tot));
      debito.Text := FMovimento.FloatStr(FloatToStr(DebitoI));
    end;
    if (cred >= 0) and (cred <tot) then debito.Text := FMovimento.FloatStr(FloatToStr((debitoi)+(tot-cred)));
    tot := StrToFloat(DEBITO.Text);
    cred:= StrToFloat(troco.Text); //TROCO
    if (cred > 0) and (cred >=tot)then begin
      troco.Text := FMovimento.FloatStr(FloatToStr(cred-tot)); // troco
      debito.Text := '0,00';
    end;
    if (cred >= 0) and (cred < tot) then  begin
      Debito.Text := FMovimento.FloatStr(FloatToStr(StrToFloat(debito.text)-cred)); //DEBITO
      troco.Text := '0,00';
    end;
  end;
end; // if

if StrToFloat(debito.text)>debitoI then z:=1;
if z=1 then diferenca := Fmovimento.FloatStr(FloatToStr(StrToFloat(debito.text) - debitoi));
if (z=1) and (MessageDlg('VOC AUMENTOU : R$ ' + diferenca + '   de Dbito ' + ' DESEJA REALMENTE  < E N C E R R A R > ?' + #13 , mtConfirmation, [mbYes,mbNo], 0)=mrYes) then
begin
encerra;
end;// else debito.text := FMovimento.FloatStr(FloatToStr(debitoi));
if z=0 then encerra;
end;

procedure TFDTodos.DataDChange(Sender: TObject);
begin
if DataModule1.TLancamento.RecordCount > 0 then begin
  multa.text := FMovimento.FloatStr(FloatToStr(valormulta));
  if (g.Height=55) and (valormulta>0) then g.Height := 180;
  if (g.Height=180) and (totali=0) and (valormulta=0) then g.Height := 55;
end;
end;

procedure TFDTodos.BitBtn3Click(Sender: TObject);
begin
if DataModule1.TLancamento.RecordCount > 0 then begin
  multa.text := FMovimento.FloatStr(FloatToStr(valormulta));
  if (g.Height=55) and (valormulta>0) then g.Height := 180;
  if (g.Height=180) and (totali=0) and (valormulta=0) then g.Height := 55;
end;
end;

procedure TFDTodos.SpeedButton1Click(Sender: TObject);
begin
//FCTodos.ShowModal;
end;

procedure TFDTodos.ClienteKeyPress(Sender: TObject; var Key: Char);
begin

if key=#13 then
begin

if Trim(Cliente.Text)<>'' then
begin
  cursor := crHourGlass;
  DataModule1.TClientes.IndexName := 'Cdigo';
  if DataModule1.TClientes.FindKey([StrToInt(cliente.text)]) then
  begin
    Nome.Text := DataModule1.TClientes.FieldByName('CliNome').asString;
    DataModule1.TMovimento.Filter := '';
    DataModule1.TMovimento.Filtered := False;
    DataModule1.TMovimento.IndexName := 'MovCliente';
    if DataModule1.TMovimento.FindKey([StrToInt(cliente.text)]) then
       registro := IntToStr(DataModule1.TMovimento.FieldByName('Registro').asInteger)
    else registro := '';
    if Registro<>'' then
    begin
      DataModule1.TLancamento.Filtered := False;
      DataModule1.TLancamento.Filter := 'LMovRegistro = ' + registro +
         ' And LDevolvido= ' + '''' + 'No'+ '''';
       DataModule1.TLancamento.Filtered := True;
    end;
        if DataModule1.TLancamento.RecordCount=0 then ShowMessage('Cliente sem FILMES ALUGADOS !');
    if registro<>'' then alimenta else zera;
  end
  else begin
    ShowMessage('Cliente no CADASTRADO !');
    zera;
  end;
  FDTodos.cursor := crDeFault;
  cursor := crDeFault;
end else begin
  nome.text := '';
  SaldoI :='';
  TotalI := 0;
  DebitoI := 0;
  zera;
end;

end;
end;



procedure TFDTodos.filmeKeyPress(Sender: TObject; var Key: Char);
var table : TTable;
begin


if (key = #13) then
begin
if trim(filme.text)<>'' then
begin
DataModule1.TLancamento.Filtered := False;
table := TTable.Create(Self);
with table do begin
  databasename := 'Locadora';
  TableName := 'Lancamento.db';
  open;
  filtered := false;
  filter := 'LDevolvido = ' + '''' + 'No' + '''';
  filtered := true;
  IndexName := 'LFilme';
  registro := '';
  if FindKey([StrToInt(filme.text)]) then
  begin
    registro := IntToStr(FieldByName('LMovRegistro').AsInteger);
    cli := FieldByName('LCliente').AsInteger;
  end;
  close;
  free;
DataModule1.TLancamento.Filtered := True;  
end;
  if not (registro='') then
  begin
    cursor := crHourGlass;
    DataModule1.TClientes.IndexName := 'Cdigo';
    if DataModule1.TClientes.FindKey([cli]) then
    begin
      Nome.Text := DataModule1.TClientes.FieldByName('CliNome').asString;
      cliente.Text := IntToStr(cli);
    end
    else begin
      ShowMessage('Cliente no CADASTRADO !');
      zera;
    end;
    DataModule1.TLancamento.Filtered := False;
    DataModule1.TLancamento.Filter := 'LMovRegistro = ' + registro +
      ' And LDevolvido= ' + '''' + 'No'+ '''';
    DataModule1.TLancamento.Filtered := True;
    if DataModule1.TLancamento.RecordCount>0 then alimenta
    else begin
      registro := '';
      zera;
      ShowMessage('Cliente sem FILMES ALUGADOS !')
    end;
    FDTodos.cursor := crDeFault;
    cursor := crDeFault;
  end;
end else zera;
end;// key=13
end;

procedure TFDTodos.DBGrid1DblClick(Sender: TObject);

 function multaind : real;
  var x : integer;
     data : TDateTime;
  begin
     result := 0;
     if DataD.Date > DataModule1.TLancamento.FieldByName('LDataDevolucao').AsDateTime then
     begin
        x := 0;
        data := DataModule1.TLancamento.FieldByName('LDataDevolucao').AsDateTime;
        data := IncDay(Data,1);
        while data <= DataD.Date do
        begin
         data := IncDay(Data,1);
         x:= x + 1;
        end;
        result := x * DataModule1.TLancamento.FieldByName('ValoCategoria').AsFloat;
      end;
  end;

  procedure baixa;
  begin
    // devolvendo filme
      with DataModule1.TLancamento do
      begin

     // Devolvendo filme na tabela de filmes
       DataModule1.TFilmes.IndexFieldNames := 'FilCodigo';
       DataModule1.TFilmes.FindKey([FieldByName('LFilme').asInteger]);
       DataModule1.TFilmes.Edit;
       DataModule1.TFilmes.FieldByName('FilAlugado').asString := 'No';
       DataModule1.TFilmes.FieldByName('FilMR').value := null;
       DataModule1.TFilmes.Post;

     // Devolvendo filme na tabela de lancamentos
       edit;
       FieldByName('LDataDR').AsDateTime := DataD.Date;
       FieldByName('LDevolvido').asString := 'Sim';
       FieldByName('LHoraDevolucao').AsDateTime := Time;
       post;
       alimenta;
       credito.text := '0,00';
       troco.text := '0,00';

     end;
  end;

begin

if MessageDlg('DESEJA DEVOLVER ?' + #13 , mtConfirmation, [mbYes,mbNo], 0)=mrYes then
begin

  if (DataModule1.TLancamento.FieldByName('LPag').asString='DEV') then
  begin
    pag := 'I';
    total.text := FMovimento.FloatStr(DataModule1.TLancamentoValoCategoria.AsString);
    multa.text := FMovimento.FloatStr(FloatToStr(multaind));
    credito.setfocus;
    abort;
  end;
  if ((DataModule1.TLancamento.FieldByName('LPag').asString='ATO') and (multaind>0))then
  begin
     if(MessageDlg('DESEJA COBRAR M U L T A ?' + #13 , mtConfirmation, [mbYes,mbNo], 0)=mrYes) then
     begin
       pag := 'I';
       multa.text := '0,00';
       total.text := FMovimento.FloatStr(FloatToStr(multaind));
       credito.setfocus;
       abort;
     end else baixa;
  end;
  if (DataModule1.TLancamento.FieldByName('LPag').asString='ATO') and (multaind=0) then Baixa;

end;
end;


end.
