unit u_Filmes;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, StdCtrls, Mask, DBCtrls, Buttons, ExtCtrls, DBTables;

type
  TFFilmes = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    DBEdit3: TDBEdit;
    Label3: TLabel;
    Label2: TLabel;
    DBEdit4: TDBEdit;
    Label4: TLabel;
    DBEdit5: TDBEdit;
    Label5: TLabel;
    DBEdit2: TDBEdit;
    GroupBox3: TGroupBox;
    Label6: TLabel;
    DBEdit6: TDBEdit;
    Label7: TLabel;
    DBEdit7: TDBEdit;
    Label8: TLabel;
    DBEdit8: TDBEdit;
    Label9: TLabel;
    DBEdit9: TDBEdit;
    Label10: TLabel;
    DBEdit10: TDBEdit;
    Label11: TLabel;
    DBEdit11: TDBEdit;
    Label12: TLabel;
    DBEdit12: TDBEdit;
    Panel1: TPanel;
    novo: TBitBtn;
    gravar: TBitBtn;
    editar: TBitBtn;
    deletar: TBitBtn;
    cancelar: TBitBtn;
    navegador: TDBNavigator;
    localiza: TBitBtn;
    BitBtn2: TBitBtn;
    gen: TDBLookupComboBox;
    dis: TDBLookupComboBox;
    cat: TDBLookupComboBox;
    GroupBox4: TGroupBox;
    DBEdit14: TDBEdit;
    Label14: TLabel;
    DBEdit13: TDBEdit;
    Label13: TLabel;
    DBComboBox1: TDBComboBox;
    Label15: TLabel;
    DBComboBox2: TDBComboBox;
    Label16: TLabel;
    DBEdit1: TDBEdit;
    Label1: TLabel;
    procedure novoClick(Sender: TObject);
    procedure editarClick(Sender: TObject);
    procedure deletarClick(Sender: TObject);
    procedure cancelarClick(Sender: TObject);
    procedure gravarClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure catClick(Sender: TObject);
    procedure localizaClick(Sender: TObject);
  private
    { Private declarations }
    procedure tabelavazia;
    procedure botoes;
    function duplicado(x:integer):boolean;
  public
    { Public declarations }
  end;

var
  FFilmes: TFFilmes;
  velho : Integer;
implementation

uses u_DM, u_cFilmes;

{$R *.dfm}

function TFFilmes.duplicado(x:integer):boolean;
var
t: TTable;
begin
t := TTable.create(self);
with t do
begin
DatabaseName := 'Locadora'; {Nome do Alias}
TableName := 'Filmes.db';
IndexFieldNames:='FilCodigo';
open;
if DataModule1.TFilmes.State =DsEdit then
begin
if velho<>strtoint(dbedit1.text) then
begin
  if findkey([x]) then result:=true
  else result:=false;
end
else result := false;
end;

if DataModule1.TFilmes.State =DsInsert then
begin
  if findkey([x]) then result:=true
  else result:=false;
end;
close;
free;
end;
end;


procedure TFFilmes.tabelavazia;
begin
if datamodule1.TFilmes.recordcount<1 then
begin
  novo.enabled:=true;
  editar.enabled:=false;
  deletar.enabled:=false;
  cancelar.Enabled:=false;
  gravar.Enabled:=false;
  localiza.enabled := false;
end
else begin
  novo.enabled:=true;
  editar.enabled:=true;
  deletar.enabled:=true;
  cancelar.Enabled:=false;
  gravar.Enabled:=false;
  navegador.enabled:=true;
  localiza.enabled := true;
end;
end;

procedure TFFilmes.botoes;
begin
novo.enabled:=false;
editar.enabled:=false;
deletar.Enabled:=false;
cancelar.enabled:=true;
gravar.enabled:=true;
navegador.enabled:=editar.enabled;
end;


procedure TFFilmes.novoClick(Sender: TObject);
var x:integer;
begin
DataModule1.TFilmes.IndexName := '';
DataModule1.Tfilmes.IndexFieldNames := 'FilCodigo';
DataModule1.TFilmes.Last;
x := (DataModule1.TFilmes.FieldByName('FilCodigo').AsInteger + 1);
localiza.Enabled := false;
datamodule1.DSFilmes.AutoEdit:=true;
datamodule1.TFilmes.Insert;
DataModule1.TFilmes.FieldByName('FilCodigo').AsInteger := x;
dbedit1.setfocus;
dis.enabled := true;
cat.enabled := true;
gen.enabled := true;
botoes;
end;

procedure TFFilmes.editarClick(Sender: TObject);
begin
localiza.Enabled := false;
velho:=strtoint(dbedit1.text);
datamodule1.TFilmes.Edit;
datamodule1.DSFilmes.AutoEdit:=true;
//controla botoes enabled
botoes;
dbedit1.setfocus;
dis.enabled := true;
cat.enabled := true;
gen.enabled := true;
end;

procedure TFFilmes.deletarClick(Sender: TObject);
begin
if MessageDlg('EXCLUIR O REGISTRO?', mtConfirmation, [mbYes,mbNo], 0)=mrYes then
begin
  datamodule1.TFilmes.delete;
end;
tabelavazia;
end;

procedure TFFilmes.cancelarClick(Sender: TObject);
begin
datamodule1.TFilmes.Cancel;
//controla botoes enabled
novo.enabled:=true;
editar.enabled:=true;
deletar.enabled:=true;
cancelar.Enabled:=false;
gravar.Enabled:=false;
navegador.enabled:=true;
tabelavazia;
dis.enabled := false;
cat.enabled := false;
gen.enabled := false;
end;

procedure TFFilmes.gravarClick(Sender: TObject);
begin
if (not duplicado(strtoint(dbedit1.text))) then
begin
  novo.enabled:=true;
  editar.enabled:=true;
  deletar.enabled:=true;
  cancelar.Enabled:=false;
  gravar.Enabled:=false;
  navegador.Enabled:=true;
  DataModule1.TFilmes.post;
  datamodule1.TFilmes.IndexFieldNames := '';
  dis.enabled := false;
  cat.enabled := false;
  gen.enabled := false;
  localiza.enabled := true;
  datamodule1.DSFilmes.AutoEdit := false;
end
else begin
  showmessage('Registro duplicado');
  dbedit1.setfocus;
end;
end;

procedure TFFilmes.BitBtn2Click(Sender: TObject);
begin
close;
end;

procedure TFFilmes.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if (datamodule1.TFilmes.State = dsinsert) or (datamodule1.TFilmes.State = dsEdit)
then datamodule1.TFilmes.Cancel;
end;

procedure TFFilmes.FormShow(Sender: TObject);
begin
datamodule1.TFilmes.IndexFieldNames := '';
datamodule1.TFilmes.IndexName := 'Cdigo';
datamodule1.TFilmes.First;
datamodule1.DSFilmes.AutoEdit:=false;
//controla botoes enabled
tabelavazia;
dis.enabled := false;
cat.enabled := false;
gen.enabled := false;
end;

procedure TFFilmes.catClick(Sender: TObject);
begin
DataModule1.TFilmes.FieldByName('FilValorCategoria').AsFloat :=
  DataModule1.TCategoria.FieldByName('CatValor').AsFloat;
end;

procedure TFFilmes.localizaClick(Sender: TObject);
begin
FCFilmes.ShowModal;
end;

end.
