unit u_Genero;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Mask, DBCtrls, Buttons, ExtCtrls, DB, DBTables, Grids,
  DBGrids;

type
  TFGenero = class(TForm)
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    DBEdit2: TDBEdit;
    DBEdit4: TDBEdit;
    DBCheckBox1: TDBCheckBox;
    DBEdit1: TDBEdit;
    Label1: TLabel;
    Panel1: TPanel;
    novo: TBitBtn;
    gravar: TBitBtn;
    editar: TBitBtn;
    deletar: TBitBtn;
    cancelar: TBitBtn;
    navegador: TDBNavigator;
    BitBtn2: TBitBtn;
    DBGrid1: TDBGrid;
    procedure novoClick(Sender: TObject);
    procedure editarClick(Sender: TObject);
    procedure cancelarClick(Sender: TObject);
    procedure gravarClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure deletarClick(Sender: TObject);
  private
    { Private declarations }
    procedure tabelavazia;
    procedure botoes;
    function duplicado(x:integer):boolean;
  public
    { Public declarations }
  end;

var
  FGenero: TFGenero;
  velho : integer;
implementation

uses u_DM;

{$R *.dfm}

function TFGenero.duplicado(x:integer):boolean;
var
t: TTable;
begin
t := TTable.create(self);
with t do
begin
DatabaseName := 'Locadora'; {Nome do Alias}
TableName := 'Genero.db';
IndexFieldNames:='GenCodigo';
open;
if DataModule1.TGenero.State =DsEdit then
begin
if velho<>strtoint(dbedit1.text) then
begin
  if findkey([x]) then result:=true
  else result:=false;
end
else result := false;
end;

if DataModule1.TGenero.State =DsInsert then
begin
  if findkey([x]) then result:=true
  else result:=false;
end;
close;
free;
end;
end;


procedure TFGenero.tabelavazia;
begin
if datamodule1.TGenero.recordcount<1 then
begin
  novo.enabled:=true;
  editar.enabled:=false;
  deletar.enabled:=false;
  cancelar.Enabled:=false;
  gravar.Enabled:=false;
end
else begin
  novo.enabled:=true;
  editar.enabled:=true;
  deletar.enabled:=true;
  cancelar.Enabled:=false;
  gravar.Enabled:=false;
  navegador.enabled:=true;
end;
end;

procedure TFGenero.botoes;
begin
novo.enabled:=false;
editar.enabled:=false;
deletar.Enabled:=false;
cancelar.enabled:=true;
gravar.enabled:=true;
navegador.enabled:=editar.enabled;
end;


procedure TFGenero.novoClick(Sender: TObject);
var x:integer;
begin
DataModule1.TGenero.Last;
x := (DataModule1.TGenero.FieldByName('GenCodigo').AsInteger + 1);
datamodule1.DSGenero.AutoEdit:=true;
datamodule1.TGenero.Insert;
DataModule1.TGenero.FieldByName('GenCodigo').AsInteger := x;
datamodule1.TGenero.FieldByName('GenCensura').asBoolean := False;
dbedit1.setfocus;
botoes;
end;

procedure TFGenero.editarClick(Sender: TObject);
begin
velho:=strtoint(dbedit1.text);
datamodule1.TGenero.Edit;
datamodule1.DSGenero.AutoEdit:=true;
//controla botoes enabled
botoes;
dbedit1.setfocus;
end;

procedure TFGenero.cancelarClick(Sender: TObject);
begin
datamodule1.TGenero.Cancel;
//controla botoes enabled
novo.enabled:=true;
editar.enabled:=true;
deletar.enabled:=true;
cancelar.Enabled:=false;
gravar.Enabled:=false;
navegador.enabled:=true;
tabelavazia;
end;

procedure TFGenero.gravarClick(Sender: TObject);
begin
if (not duplicado(strtoint(dbedit1.text))) then
begin
  novo.enabled:=true;
  editar.enabled:=true;
  deletar.enabled:=true;
  cancelar.Enabled:=false;
  gravar.Enabled:=false;
  navegador.Enabled:=true;
  DataModule1.TGenero.post;
  datamodule1.TGenero.IndexFieldNames := '';
  DataModule1.DsGenero.AutoEdit := false;
end
else begin
  showmessage('Registro duplicado');
  dbedit1.setfocus;
end;
end;

procedure TFGenero.BitBtn2Click(Sender: TObject);
begin
close;
end;

procedure TFGenero.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if (datamodule1.TGenero.State= dsinsert) or (datamodule1.TGenero.State = dsEdit)
then datamodule1.TGenero.Cancel;

end;

procedure TFGenero.FormShow(Sender: TObject);
begin
datamodule1.TGenero.First;
datamodule1.DSGenero.AutoEdit:=false;
//controla botoes enabled
tabelavazia;
end;

procedure TFGenero.deletarClick(Sender: TObject);
begin
DataModule1.TFilmes.IndexName := 'FilGenero';
if DataModule1.TFilmes.FindKey([DataModule1.TGenero.FieldByName('GenCodigo').asInteger]) then
begin
   ShowMessage('Gnero Vinculado na Tabela de Filmes');
end
else begin
if MessageDlg('EXCLUIR O REGISTRO?', mtConfirmation, [mbYes,mbNo], 0)=mrYes then
begin
  datamodule1.TGenero.delete;
end;
tabelavazia;
end;
end;

end.
