unit u_MBaixaDebito;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, DBGrids, StdCtrls, Buttons, SuperEdit, ExtCtrls;

type
  TFMBaixaDebito = class(TForm)
    codigo: TSuperEdit;
    SpeedButton1: TSpeedButton;
    nome: TSuperEdit;
    Label1: TLabel;
    Label2: TLabel;
    DBGrid1: TDBGrid;
    g: TGroupBox;
    a2: TLabel;
    a4: TLabel;
    Label8: TLabel;
    Bevel3: TBevel;
    Bevel2: TBevel;
    Bevel1: TBevel;
    Bevel6: TBevel;
    Bevel9: TBevel;
    Bevel10: TBevel;
    encerra: TBitBtn;
    credito: TEdit;
    troco: TEdit;
    total: TEdit;
    debito: TEdit;
    a7: TLabel;
    procedure codigoChange(Sender: TObject);
    procedure creditoKeyPress(Sender: TObject; var Key: Char);
    procedure DBGrid1CellClick(Column: TColumn);
    procedure encerraClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FMBaixaDebito: TFMBaixaDebito;
  debitoi,totali : real;
implementation

uses u_DM, u_MLocacao, u_CDClientes;

{$R *.dfm}

procedure TFMBaixaDebito.codigoChange(Sender: TObject);
begin

if Trim(codigo.text)<>'' then
begin
  DataModule1.TClientes.IndexName := 'Cdigo';
  if DataModule1.TClientes.Findkey([codigo.text]) then
  begin
     nome.text := DataModule1.TClientes.FieldByName('CliNome').asString;
     DataModule1.TMovimento.Filtered := false;
     DataModule1.TMovimento.Filter := 'MovCliente = ' + codigo.text +
      ' and MovValorDebito > 0 ';
     DataModule1.TMovimento.Filtered := true;
     if DataModule1.TMovimento.RecordCount > 0 then
     begin
       total.Text := FMovimento.FloatStr(FloatToStr(DataModule1.TMovimento.FieldByName('MovValorDebito').AsFloat));
       debito.text := total.text;
     end
     else begin
       credito.text := '0,00';
       debito.text := '0,00';
       troco.text := '0,00';
       total.text := '0,00';
     end;
  end
  else begin
    nome.text := '';
    DataModule1.TMovimento.Filtered := false;
    DataModule1.TMovimento.Filter := 'MovCliente > 9999999';
    DataModule1.TMovimento.Filtered := true;
  end;
end;

end;

procedure TFMBaixaDebito.creditoKeyPress(Sender: TObject; var Key: Char);
var tot,cred : real;
begin
if (key in ['a'..'z']) and (key in ['A'..'Z']) then key := #0;
if key = #13 then
begin
  if Trim(credito.Text)<>'' then begin
    tot := StrToFloat(total.Text);
    cred := StrToFloat(credito.Text);
    if (cred >=tot)then begin
      troco.Text := FMovimento.FloatStr(FloatToStr(cred-tot));
      debito.Text := '0,00';
    end;
    if (cred >= 0) and (cred <tot) then debito.Text := FMovimento.FloatStr(FloatToStr(tot-cred));
    encerra.Enabled := true;

  end;
end;
end;

procedure TFMBaixaDebito.DBGrid1CellClick(Column: TColumn);
begin
total.text := FMovimento.FloatStr(FloatToStr(DataModule1.TMovimento.FieldByName('MovValorDebito').AsFloat));
troco.text := '0,00';
debito.text := total.text;
totali := Strtofloat(total.text);
debitoi := StrToFloat(debito.text);
end;

procedure TFMBaixaDebito.encerraClick(Sender: TObject);
begin
DataModule1.TMovimento.Edit;
DataModule1.TMovimento.FieldByName('MovValorDebito').AsFloat := StrtoFloat(debito.text);
DataModule1.TMovimento.Post;

DataModule1.TCaixa.FindKey([Date]);
DataModule1.TCaixa.Edit;
DataModule1.TCaixa.FieldByName('Troco').asFloat := DataModule1.TCaixa.FieldByName('Troco').asFloat +
  StrToFloat(troco.Text);
DataModule1.TCaixa.FieldByName('Entrada').asFloat := DataModule1.TCaixa.FieldByName('Entrada').asFloat +
  StrToFloat(credito.Text);
DataModule1.TCaixa.FieldByName('SaldoFinal').asFloat := DataModule1.TCaixa.FieldByName('SaldoInicial').asFloat +
  (DataModule1.TCaixa.FieldByName('Entrada').asFloat -
   DataModule1.TCaixa.FieldByName('Troco').asFloat);

DataModule1.TCaixa.Post;

if DataModule1.TMovimento.RecordCount > 0 then
begin
  total.Text := FMovimento.FloatStr(FloatToStr(DataModule1.TMovimento.FieldByName('MovValorDebito').AsFloat));
  debito.text := total.text;
  credito.text := '0,00';
end
else begin
  credito.text := '0,00';
  debito.text := '0,00';
  troco.text := '0,00';
  total.text := '0,00';
end;
encerra.Enabled := false;

end;

procedure TFMBaixaDebito.FormShow(Sender: TObject);
begin
encerra.Enabled := false;
codigo.text := '';
nome.text := '';
DataModule1.TMovimento.Filtered := false;
DataModule1.TMovimento.Filter := 'MovCliente > 9999999';
DataModule1.TMovimento.Filtered := true;
troco.text := '0,00';
debito.text := '0,00';
total.text := '0,00';
credito.text := '0,00';
end;

procedure TFMBaixaDebito.SpeedButton1Click(Sender: TObject);
begin
FCC.Formulario := 'FMBaixaDebito';
FCC.ShowModal;
end;

end.
