unit u_principal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, DateUtils, Buttons, ExtCtrls, jpeg, DBCtrls,
  DB, DBTables, DBIProcs, Mask, ComCtrls, ToolWin;

type
  TFPrincipal = class(TForm)
    MainMenu1: TMainMenu;
    Cadastro1: TMenuItem;
    Clientes1: TMenuItem;
    Sair1: TMenuItem;
    Usurios1: TMenuItem;
    Filmes1: TMenuItem;
    N1: TMenuItem;
    Gnero1: TMenuItem;
    Distribuidores1: TMenuItem;
    Categorias1: TMenuItem;
    Movimento1: TMenuItem;
    Locao1: TMenuItem;
    Devoluo1: TMenuItem;
    Consultas1: TMenuItem;
    Relatrios1: TMenuItem;
    BitBtn1: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    Caixa1: TMenuItem;
    Locaesativas1: TMenuItem;
    SaldoNegativo1: TMenuItem;
    QuantidadedeLocaes1: TMenuItem;
    SaldodeCaixa1: TMenuItem;
    RankingdeFilmes1: TMenuItem;
    RankingdeClientes1: TMenuItem;
    DevoluesAtrazadas1: TMenuItem;
    BaixadeSaldos1: TMenuItem;
    EstornoLanaDbitos1: TMenuItem;
    Panel1: TPanel;
    Label1: TLabel;
    Table1: TTable;
    DataSource1: TDataSource;
    Table1CODIGO: TAutoIncField;
    Table1NOTAS: TMemoField;
    Table1DATA: TStringField;
    Panel2: TPanel;
    DBMemo1: TDBMemo;
    DBNavigator1: TDBNavigator;
    DBEdit1: TDBEdit;
    Label2: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    barra: TStatusBar;
    tempo: TTimer;
    LocaesporUsurios1: TMenuItem;
    ListagemdeClientes1: TMenuItem;
    ListagemdoAcervo1: TMenuItem;
    Utilitrios1: TMenuItem;
    N2Calculadora1: TMenuItem;
    N3Calendrio1: TMenuItem;
    Sobre1: TMenuItem;
    BitBtn2: TBitBtn;
    Label4: TLabel;
    procedure Sair1Click(Sender: TObject);
    procedure Clientes1Click(Sender: TObject);
    procedure Filmes1Click(Sender: TObject);
    procedure Usurios1Click(Sender: TObject);
    procedure Gnero1Click(Sender: TObject);
    procedure Distribuidores1Click(Sender: TObject);
    procedure Categorias1Click(Sender: TObject);
    procedure Locao1Click(Sender: TObject);
    procedure Devoluo1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Caixa1Click(Sender: TObject);
    procedure Locaesativas1Click(Sender: TObject);
    procedure SaldoNegativo1Click(Sender: TObject);
    procedure SaldodeCaixa1Click(Sender: TObject);
    procedure RankingdeFilmes1Click(Sender: TObject);
    procedure QuantidadedeLocaes1Click(Sender: TObject);
    procedure DevoluesAtrazadas1Click(Sender: TObject);
    procedure RankingdeClientes1Click(Sender: TObject);
    procedure BaixadeSaldos1Click(Sender: TObject);
    procedure EstornoLanaDbitos1Click(Sender: TObject);
    procedure Table1AfterPost(DataSet: TDataSet);
    procedure Table1AfterDelete(DataSet: TDataSet);
    procedure Table1AfterInsert(DataSet: TDataSet);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure LocaesporUsurios1Click(Sender: TObject);
    procedure ListagemdeClientes1Click(Sender: TObject);
    procedure ListagemdoAcervo1Click(Sender: TObject);
    procedure N2Calculadora1Click(Sender: TObject);
    procedure N3Calendrio1Click(Sender: TObject);
    procedure Sobre1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FPrincipal: TFPrincipal;

implementation

uses u_Clientes, u_Filmes, u_Usuarios, u_Genero, u_Distribuidor,
  u_Categoria, u_MLocacao, u_PreMovimento, u_MDevolucao, u_DTodos,
  u_RCliFilmes, u_DM, u_Caixa, u_cCSaldoNegativo, u_RFSaldo, u_RFRanking,
  u_CQuantidadeLocacoes, u_CDevolucoesAtrazadas, u_cRankingClientes,
  u_MBaixaDebito, u_BCDebito, u_FiltroUsuario, u_rclientes, u_rFilmes,
  u_cNotas, u_Calendario, u_Sobre;

{$R *.dfm}

procedure TFPrincipal.Sair1Click(Sender: TObject);
begin
if MessageDlg('DESEJA REALMENTE - S A I R ?' + #13 , mtConfirmation, [mbYes,mbNo], 0)=mrYes then
Application.Terminate;
end;

procedure TFPrincipal.Clientes1Click(Sender: TObject);
begin
FClientes.ShowModal;
end;

procedure TFPrincipal.Filmes1Click(Sender: TObject);
begin
FFilmes.ShowModal;
end;

procedure TFPrincipal.Usurios1Click(Sender: TObject);
begin
FUsuario.ShowModal;
end;

procedure TFPrincipal.Gnero1Click(Sender: TObject);
begin
FGenero.ShowModal;
end;

procedure TFPrincipal.Distribuidores1Click(Sender: TObject);
begin
FDistribuidor.ShowModal;
end;

procedure TFPrincipal.Categorias1Click(Sender: TObject);
begin
FCategoria.ShowModal;
end;

procedure TFPrincipal.Locao1Click(Sender: TObject);
begin
FPreMovimento.ShowModal;
end;

procedure TFPrincipal.Devoluo1Click(Sender: TObject);
begin
FDTodos.ShowModal;
end;

procedure TFPrincipal.Button1Click(Sender: TObject);
var x:TDateTime;
begin
x:=date;
x:=IncDay(x,2);
ShowMessage(DateToStr(x));
end;

procedure TFPrincipal.BitBtn1Click(Sender: TObject);
begin
FPreMovimento.ShowModal;
end;

procedure TFPrincipal.BitBtn2Click(Sender: TObject);
begin
FNotas.Show;
end;

procedure TFPrincipal.BitBtn3Click(Sender: TObject);
begin
FDTodos.ShowModal;

end;

procedure TFPrincipal.BitBtn4Click(Sender: TObject);
begin
DataModule1.TLancamento.Filtered := False;
DataModule1.TLancamento.Filter := 'LDevolvido = ' + ''''  + 'No' + '''';
DataModule1.TLancamento.IndexFieldNames := '';
DataModule1.TLancamento.IndexName := 'LCliente';
DataModule1.TLancamento.Filtered := True;
FRCFilmes.QuickRep1.Preview;
end;

procedure TFPrincipal.FormShow(Sender: TObject);
begin
PANEL2.Visible := FALSE;
if not DataModule1.TCaixa.FindKey([Date]) then
begin
  DataModule1.TCaixa.Insert;
  DataModule1.TCaixa.FieldByName('Data').AsDateTime := Date;
  FCaixa.ShowModal;
end;

end;

procedure TFPrincipal.Caixa1Click(Sender: TObject);
begin
FCaixa.DBEdit2.Enabled := True;
DataModule1.TCaixa.Edit;
FCaixa.ShowModal;
end;

procedure TFPrincipal.Locaesativas1Click(Sender: TObject);
begin
DataModule1.TLancamento.Filtered := False;
DataModule1.TLancamento.Filter := 'LDevolvido = ' + ''''  + 'No' + '''';
DataModule1.TLancamento.IndexFieldNames := '';
DataModule1.TLancamento.IndexName := 'LCliente';
DataModule1.TLancamento.Filtered := True;
FRCFilmes.QuickRep1.Preview;
end;

procedure TFPrincipal.SaldoNegativo1Click(Sender: TObject);
begin
FCSaldo.ShowModal;
end;

procedure TFPrincipal.SaldodeCaixa1Click(Sender: TObject);
begin
FRFSaldo.ShowModal;
end;

procedure TFPrincipal.RankingdeFilmes1Click(Sender: TObject);
begin
FRFFilmes.ShowModal;
end;

procedure TFPrincipal.QuantidadedeLocaes1Click(Sender: TObject);
begin
FCFQtdeFilmes.ShowModal;
end;

procedure TFPrincipal.DevoluesAtrazadas1Click(Sender: TObject);
begin
FCFQtdeLocacoes.Show;
end;

procedure TFPrincipal.RankingdeClientes1Click(Sender: TObject);
begin
FCRankingClientes.Show;
end;

procedure TFPrincipal.BaixadeSaldos1Click(Sender: TObject);
begin
FMBaixaDebito.ShowModal;
end;

procedure TFPrincipal.EstornoLanaDbitos1Click(Sender: TObject);
begin
FDebito.ShowModal;
end;

procedure TFPrincipal.Table1AfterPost(DataSet: TDataSet);
begin
DBISaveChanges(Table1.Handle);
end;

procedure TFPrincipal.Table1AfterDelete(DataSet: TDataSet);
begin
DBISaveChanges(Table1.Handle);
end;

procedure TFPrincipal.Table1AfterInsert(DataSet: TDataSet);
begin
DBEdit1.SetFocus;
end;

procedure TFPrincipal.SpeedButton2Click(Sender: TObject);
begin
PANEL2.Visible := FALSE;
end;

procedure TFPrincipal.SpeedButton1Click(Sender: TObject);
begin
PANEL2.Visible := TRUE;
end;

procedure TFPrincipal.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
//if ((ssAlt in Shift) and (Key = VK_F4)) then
//-Key := 0;

end;

procedure TFPrincipal.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if not (MessageDlg('DESEJA REALMENTE - S A I R ?' + #13 , mtConfirmation, [mbYes,mbNo], 0)=mrYes) then action := canone;
end;

procedure TFPrincipal.LocaesporUsurios1Click(Sender: TObject);
begin
FCUsuario.Show;
end;

procedure TFPrincipal.ListagemdeClientes1Click(Sender: TObject);
begin
FRClientes.QuickRep1.Preview;
end;

procedure TFPrincipal.ListagemdoAcervo1Click(Sender: TObject);
begin
DataModule1.TFilmes.IndexFieldNames := '';
DataModule1.TFilmes.IndexName := 'Ttulo';

FRFilmes.QuickRep1.Preview;
end;

procedure TFPrincipal.N2Calculadora1Click(Sender: TObject);
begin
winexec(pchar('calc.exe'),sw_normal);
end;

procedure TFPrincipal.N3Calendrio1Click(Sender: TObject);
begin
FCalendario.Show;
end;

procedure TFPrincipal.Sobre1Click(Sender: TObject);
begin
FSobre.ShowModal;
end;

end.
