unit u_Clientes;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DBCtrls, StdCtrls, Mask, Buttons, ExtCtrls, DB, DBTables,
  ExtDlgs;

type
  TFClientes = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    DBEdit1: TDBEdit;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    Label3: TLabel;
    DBEdit3: TDBEdit;
    Label4: TLabel;
    DBEdit4: TDBEdit;
    Label5: TLabel;
    DBEdit5: TDBEdit;
    Label6: TLabel;
    DBEdit6: TDBEdit;
    Label7: TLabel;
    DBEdit7: TDBEdit;
    Label8: TLabel;
    DBEdit8: TDBEdit;
    Label9: TLabel;
    DBEdit9: TDBEdit;
    Label10: TLabel;
    DBEdit10: TDBEdit;
    DBCheckBox1: TDBCheckBox;
    foto: TDBImage;
    Panel1: TPanel;
    novo: TBitBtn;
    gravar: TBitBtn;
    editar: TBitBtn;
    deletar: TBitBtn;
    cancelar: TBitBtn;
    navegador: TDBNavigator;
    localiza: TBitBtn;
    BitBtn2: TBitBtn;
    Bevel1: TBevel;
    ccarrega: TSpeedButton;
    Label17: TLabel;
    climpa: TSpeedButton;
    Label11: TLabel;
    DBEdit11: TDBEdit;
    autorizados: TButton;
    dialogo: TSavePictureDialog;
    Label12: TLabel;
    DBEdit12: TDBEdit;
    Label13: TLabel;
    DBEdit13: TDBEdit;
    Label14: TLabel;
    DBEdit14: TDBEdit;
    Label15: TLabel;
    DBEdit15: TDBEdit;
    procedure novoClick(Sender: TObject);
    procedure editarClick(Sender: TObject);
    procedure deletarClick(Sender: TObject);
    procedure cancelarClick(Sender: TObject);
    procedure gravarClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure autorizadosClick(Sender: TObject);
    procedure localizaClick(Sender: TObject);
    procedure climpaClick(Sender: TObject);
    procedure ccarregaClick(Sender: TObject);
  private
    { Private declarations }
    procedure tabelavazia;
    procedure botoes;
    function duplicado(x:integer):boolean;
  public
    { Public declarations }
  end;

var
  FClientes: TFClientes;
  velho : Integer;
implementation

uses u_DM, u_Autorizados, u_cClientes;

{$R *.dfm}

function TFClientes.duplicado(x:integer):boolean;
var
t: TTable;
begin
t := TTable.create(self);
with t do
begin
DatabaseName := 'Locadora'; {Nome do Alias}
TableName := 'Clientes.db';
IndexFieldNames:='CliCodigo';
open;
if DataModule1.TClientes.State =DsEdit then
begin
if velho<>strtoint(dbedit1.text) then
begin
  if findkey([x]) then result:=true
  else result:=false;
end
else result := false;
end;

if DataModule1.TClientes.State =DsInsert then
begin
  if findkey([x]) then result:=true
  else result:=false;
end;
close;
free;
end;
end;


procedure TFClientes.tabelavazia;
begin
if datamodule1.TClientes.recordcount<1 then
begin
  novo.enabled:=true;
  editar.enabled:=false;
  deletar.enabled:=false;
  cancelar.Enabled:=false;
  gravar.Enabled:=false;
  localiza.enabled := false;
end
else begin
  novo.enabled:=true;
  editar.enabled:=true;
  deletar.enabled:=true;
  cancelar.Enabled:=false;
  gravar.Enabled:=false;
  navegador.enabled:=true;
  localiza.enabled := true;
end;
end;

procedure TFClientes.botoes;
begin
novo.enabled:=false;
editar.enabled:=false;
deletar.Enabled:=false;
cancelar.enabled:=true;
gravar.enabled:=true;
navegador.enabled:=editar.enabled;
end;


procedure TFClientes.novoClick(Sender: TObject);
var x:integer;
begin
DataModule1.TClientes.IndexName := '';
DataModule1.TClientes.IndexFieldNames := 'CliCodigo';

DataModule1.TClientes.Last;
x := (DataModule1.TClientes.FieldByName('CliCodigo').AsInteger + 1);
climpa.Enabled := true;
ccarrega.Enabled := true;
localiza.Enabled := false;
autorizados.enabled := true;
datamodule1.DSClientes.AutoEdit:=true;
datamodule1.TClientes.Insert;
datamodule1.TClientes.FieldByName('Bloqueado').asBoolean := False;
DataModule1.TClientes.FieldByName('CliCodigo').AsInteger := x;
dbedit1.setfocus;
botoes;
end;

procedure TFClientes.editarClick(Sender: TObject);
begin
autorizados.enabled := true;
climpa.Enabled := true;
ccarrega.Enabled := true;
localiza.Enabled := false;
velho:=strtoint(dbedit1.text);
datamodule1.TClientes.Edit;
datamodule1.DSClientes.AutoEdit:=true;
//controla botoes enabled
botoes;
dbedit1.setfocus;
end;

procedure TFClientes.deletarClick(Sender: TObject);
begin
if MessageDlg('EXCLUIR O REGISTRO?', mtConfirmation, [mbYes,mbNo], 0)=mrYes then
begin
  datamodule1.TClientes.delete;
end;
tabelavazia;
end;

procedure TFClientes.cancelarClick(Sender: TObject);
begin
autorizados.enabled := false;
climpa.Enabled := false;
ccarrega.Enabled := false;
datamodule1.TClientes.Cancel;
//controla botoes enabled
novo.enabled:=true;
editar.enabled:=true;
deletar.enabled:=true;
cancelar.Enabled:=false;
gravar.Enabled:=false;
navegador.enabled:=true;
tabelavazia;
end;

procedure TFClientes.gravarClick(Sender: TObject);
begin
if (not duplicado(strtoint(dbedit1.text))) then
begin
  novo.enabled:=true;
  editar.enabled:=true;
  deletar.enabled:=true;
  cancelar.Enabled:=false;
  gravar.Enabled:=false;
  navegador.Enabled:=true;
  climpa.Enabled := false;
  ccarrega.Enabled := false;
  DataModule1.TClientes.post;
  autorizados.enabled := false;
  datamodule1.TClientes.IndexFieldNames := '';
  datamodule1.DSClientes.AutoEdit := False;
  localiza.enabled := true;
end
else begin
  showmessage('Registro duplicado');
  dbedit1.setfocus;
end;
end;

procedure TFClientes.BitBtn2Click(Sender: TObject);
begin
Close;
end;

procedure TFClientes.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if (datamodule1.TClientes.State = dsinsert) or (datamodule1.TClientes.State = dsEdit)
then datamodule1.TClientes.Cancel;

end;

procedure TFClientes.FormShow(Sender: TObject);
begin
DataModule1.TClientes.IndexFieldNames := '';
DataModule1.TClientes.IndexName :='Cdigo';

datamodule1.TClientes.First;
datamodule1.DSClientes.AutoEdit:=false;
//controla botoes enabled
tabelavazia;
climpa.enabled := false;
ccarrega.enabled := false;
autorizados.enabled := false;
end;

procedure TFClientes.autorizadosClick(Sender: TObject);
begin
DataModule1.TAutorizados.IndexName := 'AutCliCodigo';
DataModule1.TAutorizados.Filter := 'AutCliCodigo = ' +
IntToStr (DataModule1.TClientes.FieldByName('CliCodigo').AsInteger);
DataModule1.TAutorizados.Filtered := true;
FAutorizados.ShowModal;
DataModule1.TAutorizados.Filter := '';
DataModule1.TAutorizados.Filtered := False;
end;

procedure TFClientes.localizaClick(Sender: TObject);
begin
 FCLocalizar.ShowModal;
end;

procedure TFClientes.climpaClick(Sender: TObject);
begin
DataModule1.TClientes.FieldByName('CliFoto').Clear;
end;

procedure TFClientes.ccarregaClick(Sender: TObject);
begin
if dialogo.execute then

Foto.Picture.LoadFromFile(dialogo.FileName);
end;

end.
