unit u_MLocacao;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, DBGrids, ComCtrls, StdCtrls, DBCtrls, DB, Mask, ExtCtrls,
  DBTables, Buttons, Printers, DateUtils;

type
  TFMovimento = class(TForm)
    Bevel1: TBevel;
    Data: TLabel;
    CodCliente: TLabel;
    NomeCliente: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    PageControl1: TPageControl;
    Loc: TTabSheet;
    DBGrid1: TDBGrid;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label8: TLabel;
    Edit1: TEdit;
    datad: TMaskEdit;
    saldo: TEdit;
    lsaldo: TLabel;
    SpeedButton1: TSpeedButton;
    BitBtn2: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    PageControl2: TPageControl;
    TabSheet1: TTabSheet;
    pagamento: TGroupBox;
    Label12: TLabel;
    Label3: TLabel;
    Label2: TLabel;
    Label5: TLabel;
    Label4: TLabel;
    Ato: TRadioButton;
    Devolucao: TRadioButton;
    Edit2: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit4: TEdit;
    Edit7: TEdit;
    ComboBox1: TComboBox;
    ENCERRA: TBitBtn;
    CUPOM: TMemo;
    Button1: TButton;
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure Edit5KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit5KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ENCERRAClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure DevolucaoClick(Sender: TObject);
    procedure AtoClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    function JaLocado: Boolean;
    procedure soma;
    procedure subtrai;
    procedure Fecha;
    procedure F5;
    procedure F9;
    procedure TiraSaldo;
    function Idade:Integer;
    function IdadePermitido:Boolean;
    procedure PreencheCupom;
    procedure PrintCupom;
  public
    { Public declarations }
     MovRegistro,LCliente : Integer;
     LEAut : Boolean;
     DataDev,DataLoc,HoraLoc : TDateTime;
     debitoi:real;
     LAutNome : String;
    function FloatStr(i:string) : String;
    procedure EntraFilme;
    Function IsNumber(strNumber : String) : Boolean;
  end;

var
  FMovimento: TFMovimento;
  Cli,NomeC,Auto,DataL,SaldoI,TotalI : String;
  x : real;
  y:integer;

implementation

uses u_DM, u_PreMovimento, u_clFilmes, u_principal;

{$R *.dfm}

Function TFMovimento.IsNumber(strNumber : String) : Boolean;
var
  i : Integer;
begin
  for i:=1 to Length(strNumber) do
    begin
      if not((strNumber[i] >= #48) and (strNumber[i] <= #57)) then
        begin
          Result := False;
          Exit;
        end;
    end;
  if (strNumber <> '') then Result := True
  else                      Result := False;
end;

procedure TFMovimento.PreencheCupom;
begin
Cupom.Lines.Clear;
Cupom.Lines.Add('                           Gabi Vdeo Locadora');
Cupom.Lines.Add('-------------------------------------------------------------------------------------');
Cupom.Lines.Add('Av. Pico das Agulhas Negras, 1110 - Altos de Santana');
Cupom.Lines.Add('Hor. Funcionamento Seg, Sab. 9:00h s 20:30');
Cupom.Lines.Add('Tel: 3941-4109 - Dom. e Fer. 9:00 s 13:00h');
Cupom.Lines.Add('       ' + DateToStr(DataLoc) + '               ' + TimeToStr(Time));
Cupom.Lines.Add('-------------------------------------------------------------------------------------');
Cupom.Lines.Add('FUNC.: ' + FPrincipal.barra.panels[1].text);
Cupom.Lines.Add('-------------------------------------------------------------------------------------');
Cupom.Lines.Add('CD.: ' + IntToStr(LCliente) + '           NOME : ' + FPreMovimento.nomsel.text);
Cupom.Lines.Add('-------------------------------------------------------------------------------------');
with DataModule1.TLancamento do
begin
  First;
  while not eof do
  begin
    if not (FieldByName('Cupom').asString ='Sim') then
    begin
    Cupom.Lines.Add(IntToStr(FieldByName('LFilme').asInteger) + ' - ' +
      DataModule1.TLancamentoTitulo.asString + ' - ' +
        FloatStr(FloatToStr(FieldByName('LPreco').AsFloat)) + ' - ' +
          DateToStr(FieldByName('LDataDevolucao').asDateTime) + ' - ' +
             fieldByName('LPag').asString);
    Edit;
    FieldByName('Cupom').asString :='Sim';
    Post;
    end;
    next;
  end;
end;
Cupom.Lines.Add('-------------------------------------------------------------------------------------');
Cupom.Lines.Add('TOTAL : ' + Edit4.Text + '           - TROCO : ' + edit6.text);
Cupom.Lines.Add('PAGO : ' + edit5.text);
Cupom.Lines.Add('DBITO : ' + Edit7.Text);
Cupom.Lines.Add('');
Cupom.Lines.Add('           (_______________________________)');
Cupom.Lines.Add('           Declaro responsabilidade sobre as fitas');
Cupom.Lines.Add('         As fitas devero ser entregues at as 19:00');
Cupom.Lines.Add('         Aps este horrio ser cobrada multa diria !');
Cupom.Lines.Add('');
Cupom.Lines.Add('SCAV - Sistema para Locadora');

end;


procedure TFMovimento.EntraFilme;
function duplicado(x:Integer):boolean;
begin
  DataModule1.TLancamento.IndexName := 'LFilme';
  if DataModule1.TLancamento.FindKey([x]) then
    result := true
  else result := false;
end;
begin
  if isnumber(edit1.text) then
  begin
   DataModule1.Tfilmes.IndexName := '';
   DataModule1.TFilmes.IndexFieldNames := 'FilCodigo';
   if trim(Edit1.text)<> '' then
   begin
     if DataModule1.TFilmes.Findkey([StrtoInt(trim(edit1.text))]) then
     begin
      if IdadePermitido then
      begin
       if not duplicado(StrToInt(Edit1.Text)) then begin
          if not jalocado then
          begin
             DataModule1.TLancamento.Insert;
             DataModule1.TLancamento.FieldByName('LFilme').asInteger :=
               DataModule1.TFilmes.FieldByName('FilCodigo').AsInteger;
             DataModule1.TLancamento.FieldByName('LDevolvido').asString := 'No';
             DataModule1.TLancamento.FieldByName('LUsuario').asString := FPrincipal.barra.panels[1].text;
             DataModule1.TLancamento.FieldByName('LMovRegistro').asInteger := MovRegistro;
             DataModule1.TLancamento.FieldByName('LCliente').asInteger := LCliente;
             DataModule1.TLancamento.FieldByName('LEAut').asBoolean := LEAut;
             if LEAut then DataModule1.TLancamento.FieldByName('LAutNome').asString := LAutNome;
             DataModule1.TLancamento.FieldByName('LDataDevolucao').asDateTime := StrtoDate(DataD.Text);
             DataModule1.TLancamento.FieldByName('LDataLocacao').asDateTime := DataLoc;
             DataModule1.TLancamento.FieldByName('LHoraLocacao').asDateTime := HoraLoc;
             DataModule1.TLancamento.FieldByName('LPreco').AsFloat := DataModule1.TLancamento.FieldByName('ValoCategoria').asFloat;
             DataModule1.TLancamento.Post;
             DataModule1.TFilmes.Edit;
             DataModule1.TFilmes.FieldByName('FilAlugado').AsString := 'Sim';
             DataModule1.TFilmes.FieldByName('FilMR').AsInteger := MovRegistro ;
             DataModule1.TFilmes.Post;
             Edit1.Text := '';
          end else ShowMessage('F I L M  E    J    L O C A D O !');

       end // duplicado
       else ShowMessage ('<F I L M E > - J  - <L A N  A D O>');
       end else ShowMessage('CENSURA : ' + IntToStr(Idade) + 'anos NO PERMITIDA !');
     end; // encontrou filme
   end; // trim
  end; // is number
end;

function TFMovimento.IdadePermitido:Boolean;
begin
  DataModule1.TGenero.IndexFieldNames := 'GenCodigo';
  DataModule1.TGenero.FindKey([DataModule1.TFilmes.FieldByName('FilGenero').AsInteger]);
  if DataModule1.TGenero.FieldByName('GenCensura').AsBoolean then
  begin
    if Idade>=DataModule1.TGenero.FieldByName('CenIdade').AsInteger then result := true
  else result := False;
  end else result := true;
end;

function TFMovimento.Idade:Integer;
begin
  DataModule1.TClientes.IndexFieldNames := 'CliCodigo';
  DataModule1.TClientes.FindKey([LCliente]);
  if LEAut then
  begin
     DataModule1.TAutorizados.Filter := 'AutCliente = ' + IntToStr(LCliente);
     DataModule1.TAutorizados.Filtered:=True;
     DataModule1.TAutorizados.IndexName := 'AutNome';
     DataModule1.TAutorizados.FindKey([LAutNome]);
     result := YearsBetween(date,DataModule1.TAutorizados.FieldByName('AutDataNascimento').asDateTime);
     DataModule1.TAutorizados.IndexName := '';
     DataModule1.TAutorizados.Filter := '';
     DataModule1.TAutorizados.Filtered := false;
  end
  else result := yearsbetween(date,DataModule1.TClientes.FieldByName('CliDataNascimento').AsDateTime);
end;

procedure TFMovimento.TiraSaldo;
var tot,credito,AUX : real;
begin
  if StrToFloat(SaldoI) > StrToFloat(Edit4.Text) then
  begin
    x := (StrToFLoat(Saldo.text) - StrtoFloat(Edit4.text));
    Edit5.Text := FloatStr(FloatToStr(StrToFLoat(Saldo.text)-x));
    Saldo.Text := FloatStr(FloatToStr(x));
    LSaldo.Font.Color := clRed;
    tot := StrToFloat(Edit4.Text);
    credito := StrToFloat(Edit5.Text);
    Edit6.Text := FloatStr(FloatToStr(credito-tot));
    Edit7.Text := FloatStr(FloatToStr(tot-credito));
  end;

  if StrToFloat(SaldoI) = StrToFloat(Edit4.Text) then
  begin
   Edit5.Text := Saldo.Text;
   Saldo.Text := '0,00';
   tot := StrToFloat(Edit4.Text);
   credito := StrToFloat(Edit5.Text);
   Edit6.Text := FloatStr(FloatToStr(credito-tot));
   Edit7.Text := FloatStr(FloatToStr(tot-credito));
  end;

  if (StrToFloat(SaldoI) < StrToFloat(Edit4.Text)) and (StrToFloat(SaldoI)>0) then
  begin
  AUX := StrToFloat(Edit4.Text) - StrToFloat(Saldo.Text);
  Edit5.Text := FloatStr(FloatToStr(StrToFloat(Edit4.Text) - AUX));
  Saldo.Text := '0,00';
  end;
end;

procedure TFMovimento.fecha;
var tot,credito:real;
begin
// se a tabela nao esta vazia para fechar
if DataModule1.TLancamento.RecordCount > 0 then
begin

 if (ato.checked) and (Trim(Edit5.Text) = '') then begin
 ShowMessage('TEM QUE LANAR VALOR DE CRDITO');
 abort;
 end

 else begin
    // mensagem para confirmar dados
    if MessageDlg('DESEJA PROSSEGUIR ?' + #13 , mtConfirmation, [mbYes,mbNo], 0)=mrYes then
    begin
       DataModule1.TMovimento.IndexFieldNames := 'Registro';
       DataModule1.TMovimento.FindKey([MovRegistro]);

       //usando a tabela de movimento
       with DataModule1.TMovimento do
       begin
         Edit;
         // se eh pag no ato
         if ato.checked then begin
           DataModule1.TCaixa.FindKey([Date]);
           DataModule1.TCaixa.Edit;
           DataModule1.TCaixa.FieldByName('Troco').asFloat := DataModule1.TCaixa.FieldByName('Troco').asFloat +
              StrToFloat(Edit6.Text);
           DataModule1.TCaixa.FieldByName('Entrada').asFloat := DataModule1.TCaixa.FieldByName('Entrada').asFloat +
              StrToFloat(Edit5.Text);
           DataModule1.TCaixa.FieldByName('SaldoFinal').asFloat := DataModule1.TCaixa.FieldByName('SaldoInicial').asFloat +
            (DataModule1.TCaixa.FieldByName('Entrada').asFloat -
              DataModule1.TCaixa.FieldByName('Troco').asFloat);

           DataModule1.TCaixa.Post;

           FieldByName('MovFormaPag').asString := 'ATO';
           FieldByName('MovTotal').AsFloat := StrToFloat(Edit4.Text);
           FieldByName('MovPag').asString := combobox1.text;
           FieldByName('MovValorDebito').asFloat := StrToFloat(Edit7.Text);
           if StrToFloat(Edit7.Text) > 0 then
             FieldByName('MovDebito').asBoolean := True
           else  if StrToFloat(Edit7.Text) <= 0 then FieldByName('MovDebito').asBoolean := False;

           DataModule1.TClientes.IndexFieldNames:='CliCodigo';
           DataModule1.TClientes.FindKey([CLI]);
           DataModule1.TClientes.Edit;
           DataModule1.TClientes.FieldByName('CliSaldo').AsFloat := StrtoFloat(Saldo.Text);
           DataModule1.TClientes.Post;
           DataModule1.TLancamento.First;

           // usando tabela de lanamento
           while not DataModule1.TLancamento.Eof do
           begin
             if DataModule1.TLancamento.FieldByName('LPag').asString = '' then
             begin
               DataModule1.TLancamento.Edit;
               DataModule1.TLancamento.FieldByName('LFormaPag').asString := combobox1.Text;
               DataModule1.TLancamento.FieldByName('LPag').AsString := 'ATO';
               DataModule1.TLancamento.Post;
             end;
             DataModule1.TLancamento.Next;
           end; // tabela de lancamento

         end // pagamento no ato
         else begin // inicia pag na devolucao
           FieldByName('MovFormaPag').asString := 'DEV';
           FieldByName('MovTotal').AsFloat := StrToFloat(Edit4.Text);
           FieldByName('MovPag').asString := combobox1.text;
           FieldByName('MovValorDebito').asFloat := StrToFloat(Edit7.Text);
           if StrToFloat(Edit7.Text) > 0 then
             FieldByName('MovDebito').asBoolean := True
           else  if StrToFloat(Edit7.Text) <= 0 then FieldByName('MovDebito').asBoolean := False;

           DataModule1.TLancamento.First; // usando tabela de lancamento
           while not DataModule1.TLancamento.Eof do
           begin
             if DataModule1.TLancamento.FieldByName('LPag').AsString = '' then
             begin
             DataModule1.TLancamento.Edit;
             DataModule1.TLancamento.FieldByName('LFormaPag').asString := combobox1.Text;
             DataModule1.TLancamento.FieldByName('LPag').AsString := 'DEV';
             DataModule1.TLancamento.Post;
             end;
             DataModule1.TLancamento.Next;
           end; // with lancamento
          end; // pag ato
          Post; // gravando na tabela de movimento
          encerra.Enabled := false;
        end; // ato
        PrintCupom;
        edit5.text := '0,00';
        edit6.text := '0,00';
        Edit2.Text := '';
        Edit4.Text := '0,00';
        pagamento.Enabled := false;

      end
      else  Edit7.Text := FloatStr(FloaTToStr(debitoi));
end;

end;
end;


procedure TFMovimento.F5;
begin
  if DataModule1.TLancamento.RecordCount > 0 then
  begin
  DataModule1.TFilmes.IndexFieldNames := 'FilCodigo';
  DataModule1.TFilmes.FindKey([DataModule1.TLancamento.FieldByName('LFilme').asInteger]);
  DataModule1.TFilmes.Edit;
  DataModule1.TFilmes.FieldByName('FilAlugado').AsString := 'No';
  DataModule1.TFilmes.FieldByName('FilMR').Value := null;
  DataModule1.TFilmes.Post;
  DataModule1.TLancamento.Delete;
  Edit2.Text := '0,00';
  Edit5.Text := '0,00';
  Edit6.Text := '0,00';
  end;
end;

procedure TFMovimento.F9;
var x : integer;
begin
  if MessageDlg('DESEJA APAGAR REGISTROS ?' + #13 , mtConfirmation, [mbNo,MBYES], 1)=mrYes then
  begin
    if DataModule1.TLancamento.RecordCount > 0 then
    begin
       for x:= 1 to DataModule1.TLancamento.RecordCount do
       begin
         DataModule1.TLancamento.RecNo:=x;
         if DataModule1.TLancamento.FieldByName('LDevolvido').AsString='No' then
           DataModule1.TLancamento.Delete;
       end;
    end;
    if DataModule1.TLancamento.RecordCount = 0 then
    begin
      DataModule1.TMovimento.IndexFieldNames := 'Registro';
      DataModule1.TMovimento.FindKey([FPreMovimento.MovRegistro]);
      DataModule1.TMovimento.Delete;
    end;
    Close;
  end
  else close;
end;


procedure TFMovimento.soma;
begin
  Edit4.Text := '0,00';
  DataModule1.TLancamento.First;
  while not DataModule1.TLancamento.eof do
  begin
    if (DataModule1.TLancamento.FieldByName('LPag').asString ='') then
      Edit4.text := FloatStr(FloatToStr(DataModule1.TLancamento.FieldByName('LPreco').asFloat + StrTofloat(Edit4.text)));
    DataModule1.TLancamento.Next;
  end;
end;

procedure TFMovimento.subtrai;
begin
    Edit4.text := FloatStr(FloatToStr(StrTofloat(Edit4.text) - DataModule1.TLancamentoValoCategoria.asFloat));
end;

function TFMovimento.JaLocado:Boolean;
begin
  if DataModule1.TFilmes.FieldByName('FilAlugado').AsString = 'Sim' then result := true
  else result := false;
end;

function TFMovimento.FloatStr(i:string) : String;
var
x:boolean;
z:integer;
begin
 for z:=1 to length(i) do
 begin
   if i[z]=',' then
   begin
    x:=false;
     break;
   end
   else x:=true;
 end;
 if x then result := i + ',00'
 else result := i;
end;


procedure TFMovimento.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
if key = #13 then EntraFilme;
end;

procedure TFMovimento.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var x:real;
begin

if (key = vk_f3) then
begin
  if DataModule1.TLancamento.RecordCount > 0 then
  begin
  soma;
  pagamento.enabled := true;
  TiraSaldo;
  ato.checked := true;
  edit5.enabled := true;
  edit5.SetFocus;
  end else ShowMessage('Voc Precisa ALUGAR UM F I L M E !');
end;

if key = vk_f5 then
begin
F5;
end;

if (key = vk_f9) then
begin
if MessageDlg('DESEJA SAIR ?' + #13 , mtConfirmation, [mbNo,MBYES], 1)=mrYes then
  close;

end;

if (key=vk_f6) then FCLFilmes.ShowModal;

end;

procedure TFMovimento.FormShow(Sender: TObject);
begin
encerra.Enabled := false;
Edit4.Text := '0,00';
edit5.Enabled := false;
edit5.text := '0,00';
devolucao.checked := true;
edit6.text := '0,00';
Edit7.Text := FloatStr(FloatToStr(DataModule1.TMovimento.FieldByName('MovValorDebito').asfloat));
edit1.setfocus;
pagamento.enabled := false;
SaldoI := Saldo.Text;
y:=0;
end;

procedure TFMovimento.Edit5KeyPress(Sender: TObject; var Key: Char);
var tot,credito : real;
begin
if (key in ['a'..'z']) and (key in ['A'..'Z']) then key := #0;
if key = #13 then
begin
  if (ato.checked) and (Trim(Edit5.Text)<>'')then begin
    tot := StrToFloat(Edit4.Text);
    credito := StrToFloat(Edit5.Text);
    if (credito > 0) and (credito >=tot)then begin
       Edit6.Text := FloatStr(FloatToStr(credito-tot));
    end;
    tot := StrToFloat(Edit7.Text);
    credito := StrToFloat(Edit6.Text); //TROCO
    if (credito > 0) and (credito >=tot)then begin
      Edit6.Text := FloatStr(FloatToStr(credito-tot)); // DEBITO
      Edit7.Text := '0,00';
    end;
    if (credito >= 0) and (credito <tot) then  begin
      Edit7.Text := FloatStr(FloatToStr(StrToFloat(Edit7.text)-credito)); //DEBITO
      Edit6.Text := '0,00';
    end;

    encerra.enabled := true;
  end;
end;
end;

procedure TFMovimento.Edit2KeyPress(Sender: TObject; var Key: Char);
var
tot,desc : real;
begin
if (key in ['a'..'z']) and (key in ['A'..'Z']) then key := #0;
if (key = #13) and (trim(Edit2.Text)<>'') then
begin
  tot := StrToFloat(Edit4.Text);
  desc := StrToFloat(Edit2.Text);
  Edit4.Text := FloatStr(FloatToStr(tot-desc));
end;
end;


procedure TFMovimento.Edit2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

if key = vk_f3 then fecha;

end;

procedure TFMovimento.Edit5KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = vk_f3 then fecha;
end;

procedure TFMovimento.FormClose(Sender: TObject; var Action: TCloseAction);
begin
lsaldo.Font.color := clblack;
end;



procedure TFMovimento.ENCERRAClick(Sender: TObject);
begin
fecha;
if MessageDlg('DESEJA SAIR ?' + #13 , mtConfirmation, [mbNo,MBYES], 1)=mrYes then
  close;
end;

procedure TFMovimento.SpeedButton1Click(Sender: TObject);
begin
FCLFilmes.ShowModal;
end;

procedure TFMovimento.BitBtn2Click(Sender: TObject);
begin
f5;
end;

procedure TFMovimento.BitBtn4Click(Sender: TObject);
begin
if MessageDlg('DESEJA SAIR ?' + #13 , mtConfirmation, [mbNo,MBYES], 1)=mrYes then
  close;
end;

procedure TFMovimento.BitBtn5Click(Sender: TObject);
function pag:boolean;
begin
  result := false;
  DataModule1.TLancamento.First;
  while not DataModule1.TLancamento.eof do
  begin
     if DataModule1.TLancamento.FieldByName('LPag').AsString='' then result := true;
     DataModule1.TLancamento.Next;
  end;
end;
begin

  if (DataModule1.TLancamento.RecordCount > 0)  then
  begin
  if pag then
  begin
    soma;
    pagamento.enabled := true;

    ato.checked := true;
    edit5.enabled := true;
    edit5.SetFocus;
  end else ShowMessage('Todos os Filmes J Efetuados Pagamentos !');

  end else ShowMessage('Voc Precisa ALUGAR UM F I L M E !');
end;

procedure TFMovimento.DevolucaoClick(Sender: TObject);
begin
edit5.Enabled := devolucao.checked;
edit2.enabled := devolucao.checked;
Saldo.Text := SaldoI;
edit2.text := '';
edit5.text := '0,00';
edit6.text := '0,00';
encerra.enabled := true;
end;

procedure TFMovimento.AtoClick(Sender: TObject);
begin
if ato.checked then
begin
edit5.Enabled := ato.checked;
edit2.enabled := ato.checked;
edit5.setfocus;
TiraSaldo;
encerra.Enabled := false;
end;
end;

procedure TFmovimento.PrintCupom;
var I:Integer;
F : TextFile;
begin
PreencheCupom;
Printer.Canvas.Font.Assign(Cupom.Font);
AssignPrn(F);
Rewrite(F);
try
   for I := 0 to Cupom.Lines.Count -1 do
    WriteLn(F, Cupom.Lines[I]);
finally
   writeln(f,#23);
   CloseFile(F);
end;

end;

procedure TFMovimento.Button1Click(Sender: TObject);
begin
if Cupom.Lines.Count > 0 then PrintCupom;
end;

end.
