unit u_PreMovimento;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Mask, DB, Grids, DBGrids, DBTables,
  ExtCtrls, DBCtrls, ComCtrls,DateUtils;

type
  TFPreMovimento = class(TForm)
    nomsel: TMaskEdit;
    Label4: TLabel;
    codsel: TMaskEdit;
    Label5: TLabel;
    Bevel1: TBevel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    gcliente: TGroupBox;
    Label2: TLabel;
    bcodigo: TMaskEdit;
    bnome: TMaskEdit;
    DBGrid1: TDBGrid;
    DBImage1: TDBImage;
    gaut: TGroupBox;
    Label3: TLabel;
    nome: TMaskEdit;
    DBGrid2: TDBGrid;
    MaskEdit2: TMaskEdit;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Button1: TButton;
    data: TMonthCalendar;
    DataExtenso: TLabel;
    DBImage2: TDBImage;
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure bnomeChange(Sender: TObject);
    procedure nomeChange(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure bcodigoKeyPress(Sender: TObject; var Key: Char);
    procedure dataExit(Sender: TObject);
    procedure DBGrid2DblClick(Sender: TObject);
    procedure DBGrid2CellClick(Column: TColumn);
    procedure TabSheet2Show(Sender: TObject);
    procedure TabSheet1Show(Sender: TObject);
    procedure bnomeKeyPress(Sender: TObject; var Key: Char);
    procedure nomeKeyPress(Sender: TObject; var Key: Char);
    procedure bcodigoChange(Sender: TObject);
    procedure bcodigoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure bnomeKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure nomeKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure dataKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MaskEdit2KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure DBGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure DBGrid1CellClick(Column: TColumn);
    procedure DBGrid1EndDrag(Sender, Target: TObject; X, Y: Integer);
  private
    { Private declarations }
    procedure abertura;
    function isnumber(strNumber : String) : Boolean;
  public
    { Public declarations }
    MovRegistro : Integer;
  end;

var
  FPreMovimento: TFPreMovimento;
  var Aut : Boolean;
implementation

uses u_DM, u_MLocacao;

{$R *.dfm}



Function TFPreMovimento.IsNumber(strNumber : String) : Boolean;
var
  i : Integer;
begin
  for i:=1 to Length(strNumber) do
    begin
      if not((strNumber[i] >= #48) and (strNumber[i] <= #57)) then
        begin
          Result := False;
          Exit;
        end;
    end;
  if (strNumber <> '') then Result := True
  else                      Result := False;
end;

procedure TFPreMovimento.abertura;
function datadev(x:TDateTime):TDateTime;
begin
  if (DayOfWeek(x)=6) then result := IncDay(x,1);
  if (DayOfWeek(x)=7) then result := IncDay(x,2);
  if (DayOfWeek(x)<6) then result := IncDay(x,1);
end;

procedure filtra;
begin
DataModule1.TLancamento.IndexName := 'Movimento';
DataModule1.TLancamento.Filter := 'LMovRegistro = ' +
  IntToStr(DataModule1.TMovimento.FieldByName('Registro').asInteger) +
  ' and LDevolvido = ' + '''' + 'No' + '''';
DataModule1.TLancamento.Filtered := true;
end;

procedure ini;
begin
    DataModule1.TMovimento.Filter := '';
    DataModule1.TMovimento.Filtered := false;
    DataModule1.TMovimento.IndexName := 'MovCliente';
    if not DataModule1.TMovimento.FindKey([StrToint(codsel.text)]) then
    begin
      DataModule1.TMovimento.Insert;
      DataModule1.TMovimento.FieldByName('MovDataLocacao').AsDateTime := data.date;
      DataModule1.TMovimento.FieldByName('MovDataDevolucao').AsDateTime := datadev(Data.date);
      DataModule1.TMovimento.FieldByName('HoraLocacao').AsDateTime := StrToTime(MaskEdit2.Text);
      DataModule1.TMovimento.FieldByName('MovCliente').AsInteger := StrtoInt(codsel.text);
      DataModule1.TMovimento.FieldByName('MovEAut').asBoolean := Aut;
      if aut then DataModule1.TMovimento.FieldByName('MovAutNome').asString := nomsel.text;
      DataModule1.TMovimento.Post;
      FMovimento.MovRegistro := DataModule1.TMovimento.FieldByName('Registro').asInteger;
      FMovimento.DataLoc := data.date;
      FMovimento.HoraLoc := StrToTime(MaskEdit2.Text);
      FMovimento.DataDev := datadev(Data.date);
      FMovimento.LCliente := StrtoInt(codsel.text);
      FMovimento.LEAut := Aut;
      FMovimento.LAutNome := nomsel.text;
      FMovimento.CodCliente.Caption := codsel.text;
      FMovimento.NomeCliente.Caption := nomsel.text;
      FMovimento.datad.Text := DateToStr(datadev(data.date));

      DataModule1.TClientes.IndexName := '';
      DataModule1.TClientes.IndexFieldNames := 'CliCodigo';
      DataModule1.TClientes.FindKey([StrToInt(codsel.text)]);

      FMovimento.Saldo.Text := FMovimento.FloatStr(FloattoStr(DataModule1.TClientes.FieldByName('CliSaldo').asFLoat));
      FMovimento.Edit7.Text := FMovimento.FloatStr(FloatToStr(DataModule1.TMovimento.FieldByName('MovValorDebito').asFloat));
      FMovimento.debitoi := StrToFloat(FMovimento.Edit7.Text);
      filtra;
      FPreMovimento.Hide;
      FMovimento.ShowModal;
      FPreMovimento.Close;
    end
    else begin
      FMovimento.MovRegistro := DataModule1.TMovimento.FieldByName('Registro').asInteger;
      FMovimento.Data.Caption := DataExtenso.Caption;
      FMovimento.DataLoc := Data.date;
      FMovimento.HoraLoc := StrToTime(MaskEdit2.Text);
      FMovimento.DataDev := datadev(data.date);
      FMovimento.LCliente := StrtoInt(codsel.text);
      FMovimento.LEAut := Aut;
      FMovimento.LAutNome := nomsel.text;
      FMovimento.CodCliente.Caption := codsel.text;
      FMovimento.NomeCliente.Caption := nomsel.text;
      FMovimento.datad.Text := DateToStr(datadev(data.date));

      DataModule1.TClientes.IndexName := '';
      DataModule1.TClientes.IndexFieldNames := 'CliCodigo';
      DataModule1.TClientes.FindKey([StrToInt(codsel.text)]);

      FMovimento.Saldo.Text := FMovimento.FloatStr(FloattoStr(DataModule1.TClientes.FieldByName('CliSaldo').asFLoat));
      FMovimento.Edit7.Text := FMovimento.FloatStr(FloatToStr(DataModule1.TMovimento.FieldByName('MovValorDebito').asFloat));
      FMovimento.debitoi := StrToFloat(FMovimento.Edit7.Text);
      filtra;
      FPreMovimento.Hide;
      FMovimento.ShowModal;
      FPreMovimento.Close;
    end;
end;



begin
if (codsel.text<> '<CDIGO>') then
begin
 DataModule1.TClientes.IndexFieldNames:='CliCodigo';
 DataModule1.TClientes.FindKey([StrtoInt(codsel.text)]);
 if not DataModule1.TClientes.FieldByName('Bloqueado').asBoolean then
   ini
 else if MessageDlg('CLIENTE <B L O Q U E A D O > ! ?' + #13 + 'DESEJA PROSSEGUIR ?', mtConfirmation, [mbYes,mbNo], 0)=mrYes then
   ini;
end;
end;



procedure TFPreMovimento.Timer1Timer(Sender: TObject);
begin
codsel.font.color := clblack;
nomsel.Font.color := clblack;

end;

procedure TFPreMovimento.Timer2Timer(Sender: TObject);
begin
codsel.font.color := clred;
nomsel.Font.color := clred;
end;

procedure TFPreMovimento.bnomeChange(Sender: TObject);
begin
DataModule1.TClientes.IndexFieldNames := '';
DataModule1.TClientes.IndexName := 'Nome';
DataModule1.TClientes.FindNearest([bnome.text]);
codsel.Text := IntToStr(DataModule1.TClientes.FieldByName('CliCodigo').AsInteger);
nomsel.Text := DataModule1.TClientes.FieldByName('CliNome').AsString;
Aut := False;
gcliente.Font.Color := ClRed;
gaut.Font.Color := ClBlack;
Label4.Caption := 'CLIENTE';
end;

procedure TFPreMovimento.nomeChange(Sender: TObject);
begin
DataModule1.TAutorizados.IndexFieldNames := '';
DataModule1.TAutorizados.IndexName := 'AutNome';
DataModule1.TAutorizados.FindNearest([nome.text]);
DataModule1.TClientes.IndexFieldNames := 'CliCodigo';
DataModule1.TClientes.FindKey([DataModule1.TAutorizados.FieldByName('AutCliCodigo').asInteger]);
codsel.Text := IntToStr(DataModule1.TAutorizados.FieldByName('AutCliCodigo').AsInteger);
nomsel.Text := DataModule1.TAutorizados.FieldByName('AutNome').AsString;
Aut := True;
gcliente.Font.Color := ClBlack;
gaut.Font.Color := ClRed;
Label4.Caption := 'AUTORIZADO';
DataModule1.TClientes.IndexFieldNames := 'CliCodigo';
DataModule1.TClientes.FindKey([DataModule1.TAutorizados.FieldByName('AutCliCodigo').asInteger]);
end;

procedure TFPreMovimento.Button2Click(Sender: TObject);
begin
codsel.Text := IntToStr(DataModule1.TAutorizados.FieldByName('AutCliCodigo').AsInteger);
nomsel.Text := DataModule1.TAutorizados.FieldByName('AutNome').AsString;
Aut := True;
gcliente.Font.Color := ClBlack;
gaut.Font.Color := ClRed;
Label4.Caption := 'AUTORIZADO';
DataModule1.TClientes.IndexFieldNames := 'CliCodigo';
DataModule1.TClientes.FindKey([DataModule1.TAutorizados.FieldByName('AutCliCodigo').asInteger]);
end;

procedure TFPreMovimento.Button1Click(Sender: TObject);
var Data : String;
begin
if not (DataModule1.TAutorizados.FieldByName('AutDataNascimento').isnull) then
  Data := DateToStr(DataModule1.TAutorizados.FieldByName('AutDataNascimento').asDateTime);
 ShowMessage ('DADOS DO AUTORIZADO ...:' + #13 + #13 +
              'RG : ' + DataModule1.TAutorizados.FieldByName('AutRG').asString + #13 + #13 +
              'CPF : ' +  DataModule1.TAutorizados.FieldByName('AutCPF').asString + #13 + #13 +
              'Dat. Nasc. : ' +  Data );

end;

procedure TFPreMovimento.FormShow(Sender: TObject);
begin
data.date := date;
PageControl1.TabIndex := 0;
codsel.text := '<CDIGO>';
nomsel.text := '<SELECIONE>';
bcodigo.text := '';
bnome.text := '';
nome.text := '';
aut := false;
Shortdateformat:= 'DDDD dd" de "mmmm" de "yyyy';
DataExtenso.Caption :=DateToStr(data.date);
Shortdateformat:= 'dd/mm/yyyy';
MaskEdit2.Text := TimetoStr(Time);
codsel.Text := IntToStr(DataModule1.TClientes.FieldByName('CliCodigo').AsInteger);
nomsel.Text := DataModule1.TClientes.FieldByName('CliNome').AsString;
Aut := False;
gcliente.Font.Color := ClRed;
gaut.Font.Color := ClBlack;
Label4.Caption := 'CLIENTE';
bcodigo.SetFocus;

end;

procedure TFPreMovimento.bcodigoKeyPress(Sender: TObject; var Key: Char);
begin

if key = #13 then
begin
  abertura;
end;
end;

procedure TFPreMovimento.dataExit(Sender: TObject);
begin
Shortdateformat:= 'DDDD dd" de "mmmm" de "yyyy';
DataExtenso.Caption :=DateToStr(data.date);
Shortdateformat:= 'dd/mm/yyyy';
end;

procedure TFPreMovimento.DBGrid2DblClick(Sender: TObject);
begin
abertura;
end;

procedure TFPreMovimento.DBGrid2CellClick(Column: TColumn);
begin
if DataModule1.TAutorizados.RecordCount >=1 then
begin
DataModule1.TClientes.IndexFieldNames := 'CliCodigo';
DataModule1.TClientes.FindKey([DataModule1.TAutorizados.FieldByName('AutCliCodigo').asInteger]);
codsel.Text := IntToStr(DataModule1.TAutorizados.FieldByName('AutCliCodigo').AsInteger);
nomsel.Text := DataModule1.TAutorizados.FieldByName('AutNome').AsString;
Aut := True;
gcliente.Font.Color := ClBlack;
gaut.Font.Color := ClRed;
Label4.Caption := 'AUTORIZADO';
DataModule1.TClientes.IndexFieldNames := 'CliCodigo';
DataModule1.TClientes.FindKey([DataModule1.TAutorizados.FieldByName('AutCliCodigo').asInteger]);
end;
end;

procedure TFPreMovimento.TabSheet2Show(Sender: TObject);
begin
codsel.Text := IntToStr(DataModule1.TAutorizados.FieldByName('AutCliCodigo').AsInteger);
nomsel.Text := DataModule1.TAutorizados.FieldByName('AutNome').AsString;
Aut := True;
gcliente.Font.Color := ClBlack;
gaut.Font.Color := ClRed;
Label4.Caption := 'AUTORIZADO';
DataModule1.TClientes.IndexFieldNames := 'CliCodigo';
DataModule1.TClientes.FindKey([DataModule1.TAutorizados.FieldByName('AutCliCodigo').asInteger]);

end;

procedure TFPreMovimento.TabSheet1Show(Sender: TObject);
begin
codsel.Text := IntToStr(DataModule1.TClientes.FieldByName('CliCodigo').AsInteger);
nomsel.Text := DataModule1.TClientes.FieldByName('CliNome').AsString;
Aut := False;
gcliente.Font.Color := ClRed;
gaut.Font.Color := ClBlack;
Label4.Caption := 'CLIENTE';

end;

procedure TFPreMovimento.bnomeKeyPress(Sender: TObject; var Key: Char);
begin
if key = #13 then
begin
  abertura;
end;
end;

procedure TFPreMovimento.nomeKeyPress(Sender: TObject; var Key: Char);
begin
if key = #13 then
begin
  abertura;
end;
end;

procedure TFPreMovimento.bcodigoChange(Sender: TObject);
begin
  if isnumber(bcodigo.text) then
  begin
   DataModule1.TClientes.IndexName := '';
   DataModule1.TClientes.IndexFieldNames := 'CliCodigo';
   if trim(bcodigo.text)<> '' then
   begin
      DataModule1.TClientes.FindNearest([StrtoInt(trim(bcodigo.text))]);
      codsel.Text := IntToStr(DataModule1.TClientes.FieldByName('CliCodigo').AsInteger);
      nomsel.Text := DataModule1.TClientes.FieldByName('CliNome').AsString;
      Aut := False;
      gcliente.Font.Color := ClRed;
      gaut.Font.Color := ClBlack;
      Label4.Caption := 'CLIENTE';
    end;
  end;
end;

procedure TFPreMovimento.bcodigoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = vk_f2 then
begin
  pagecontrol1.TabIndex:=1;
  nome.setfocus;
end;

if key = vk_ESCAPE then
begin
  close;
end;

end;

procedure TFPreMovimento.bnomeKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = vk_f2 then
begin
  pagecontrol1.TabIndex:=1;
  nome.setfocus;
end;
if key = vk_ESCAPE then
begin
  close;
end;
end;

procedure TFPreMovimento.nomeKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = vk_f1 then
begin
  pagecontrol1.TabIndex:=1;
  nome.setfocus;
end;

if key = vk_ESCAPE then
begin
  close;
end;

end;

procedure TFPreMovimento.dataKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = vk_ESCAPE then
begin
  close;
end;
end;

procedure TFPreMovimento.MaskEdit2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = vk_ESCAPE then
begin
  close;
end;
end;

procedure TFPreMovimento.DBGrid1DblClick(Sender: TObject);
begin
abertura;
end;

procedure TFPreMovimento.DBGrid1KeyPress(Sender: TObject; var Key: Char);
begin
IF DataModule1.TClientes.RECORDCOUNT >= 1 THEN
BEGIN
codsel.Text := IntToStr(DataModule1.TClientes.FieldByName('CliCodigo').AsInteger);
nomsel.Text := DataModule1.TClientes.FieldByName('CliNome').AsString;
Aut := False;
gcliente.Font.Color := ClRed;
gaut.Font.Color := ClBlack;
Label4.Caption := 'CLIENTE';
END;
if key=#13 then abertura;
end;


procedure TFPreMovimento.DBGrid1CellClick(Column: TColumn);
begin
IF DataModule1.TClientes.RECORDCOUNT >= 1 THEN
BEGIN
codsel.Text := IntToStr(DataModule1.TClientes.FieldByName('CliCodigo').AsInteger);
nomsel.Text := DataModule1.TClientes.FieldByName('CliNome').AsString;
Aut := False;
gcliente.Font.Color := ClRed;
gaut.Font.Color := ClBlack;
Label4.Caption := 'CLIENTE';
END;

end;

procedure TFPreMovimento.DBGrid1EndDrag(Sender, Target: TObject; X,
  Y: Integer);
begin
IF DataModule1.TClientes.RECORDCOUNT >= 1 THEN
BEGIN
codsel.Text := IntToStr(DataModule1.TClientes.FieldByName('CliCodigo').AsInteger);
nomsel.Text := DataModule1.TClientes.FieldByName('CliNome').AsString;
Aut := False;
gcliente.Font.Color := ClRed;
gaut.Font.Color := ClBlack;
Label4.Caption := 'CLIENTE';
END;
end;

end.
