unit u_RFRanking;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, DBGrids, DB, StdCtrls, Buttons, DBTables, ComCtrls;

type
  TFRFFilmes = class(TForm)
    Query1: TQuery;
    BitBtn1: TBitBtn;
    DataSource1: TDataSource;
    DBGrid2: TDBGrid;
    Table1: TTable;
    DataSource2: TDataSource;
    Table1Registro: TAutoIncField;
    Table1DataLocacao: TDateField;
    Table1DataDevolucao: TDateField;
    Table1FilCodigo: TIntegerField;
    Table1Qtde: TIntegerField;
    datai: TDateTimePicker;
    dataf: TDateTimePicker;
    Query1LFilme: TIntegerField;
    Label1: TLabel;
    Label2: TLabel;
    BitBtn2: TBitBtn;
    Table1FilTitulo: TStringField;
    Table1ValorPago: TFloatField;
    Table1ValorLocacao: TFloatField;
    Table1Genero: TStringField;
    Table1Categoria: TStringField;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FRFFilmes: TFRFFilmes;

implementation

uses u_DM;

{$R *.dfm}

procedure TFRFFilmes.BitBtn1Click(Sender: TObject);
var qtde,X : integer;
begin

// zerando temporario

if Table1.RecordCount > 0  then
begin
   Table1.Last;
   for x:=1 to Table1.RecordCount do
   begin
    Table1.Delete;
   end;
end;

if DataI.Date <= DataF.Date then
begin
// filtrando periodo
DataModule1.TLancamento.Filtered := False;
DataModule1.TLancamento.Filter := 'LDataLocacao >= ' + '''' +
 DatetoStr(DataI.date) + '''' + ' and LDataLocacao<= ' + '''' +
   DateToStr(DataF.Date) + '''';
DataModule1.TLancamento.Filtered := True;



//abrindo consulta sobre periodo
Query1.Close;
query1.ParamByName('di').AsDate := DataI.Date;
query1.ParamByName('df').AsDate := Dataf.Date;
Query1.Open;



Query1.First;
while not Query1.eof do
begin
 qtde := 0;
 DataModule1.TLancamento.First;
 while not DataModule1.TLancamento.eof do
 begin
   if Query1.FieldByName('LFilme').AsInteger = DataModule1.TLancamento.FieldByName('LFilme').AsInteger then
     qtde := qtde + 1;
   DataModule1.TLancamento.Next;
 end;

//gravando temporario
Table1.IndexName := 'FilCodigo';
if not Table1.FindKey([Query1.FieldByName('LFilme').AsInteger]) then
begin
Table1.Insert;
Table1.FieldByName('FilCodigo').AsInteger := Query1.FieldByName('LFilme').AsInteger;
Table1.FieldByName('Qtde').AsInteger := qtde;
Table1.Post;
end;

Query1.Next;
end;
end else ShowMessage('Data Final menor que Data Inicial !');
Table1.IndexName := 'Quantidade';
TABLE1.FIRST;
end;

procedure TFRFFilmes.FormShow(Sender: TObject);
begin
datai.date := date;
dataf.date := date;
if Table1.RecordCount > 0  then
begin
   Table1.Last;
   while not Table1.Bof do Table1.Delete;
end;
Table1.First;

end;

procedure TFRFFilmes.BitBtn2Click(Sender: TObject);
begin
close;
end;

procedure TFRFFilmes.FormClose(Sender: TObject; var Action: TCloseAction);
begin
DataModule1.TLancamento.Filtered := False;
DataModule1.TLancamento.Filter := '';
end;

end.
