unit u_RFSaldo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, DBTables, StdCtrls, Buttons, ComCtrls, Printers;

type
  TFRFSaldo = class(TForm)
    datai: TDateTimePicker;
    dataf: TDateTimePicker;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Query1: TQuery;
    Query1Data: TDateField;
    Query1SaldoInicial: TCurrencyField;
    Query1Troco: TCurrencyField;
    Query1Entrada: TCurrencyField;
    Query1SaldoFinal: TCurrencyField;
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FRFSaldo: TFRFSaldo;

implementation

uses u_RSaldo;

{$R *.dfm}

procedure SetPrinterPage(Width, Height : LongInt);
var
  Device : array[0..255] of char;
  Driver : array[0..255] of char;
  Port   : array[0..255] of char;
  hDMode : THandle;
  PDMode : PDEVMODE;
begin
// obtm o DEVMODE atual
  Printer.GetPrinter(Device, Driver, Port, hDMode);
  if hDMode <> 0 then begin
// trava a memria apontada por PDMODE, para alterar
    pDMode := GlobalLock( hDMode );
// altera campos de altura e largura
    if pDMode <> nil then begin
      pDMode^.dmPaperSize   := DMPAPER_USER;
      pDMode^.dmPaperWidth  := Width;
      pDMode^.dmPaperLength := Height;
      pDMode^.dmFields := pDMode^.dmFields or
        DM_PAPERSIZE;
      GlobalUnlock( hDMode );
    end;
  end;
end;


procedure MudaTamPapel(PaperSize, Comp, Alt: integer);
var
ADevice, ADriver, APort: array[0..255] of char;
DeviceMode: THandle;
M: PDevMode;
s: string;
begin
// Fora o uso de Printer. Se esta linha for removida, a primeira
// invocao falha. Bug da VCL
S := Printer.Printers[Printer.PrinterIndex];
// Pega dados da impressora atual
Printer.GetPrinter(ADevice, ADriver, APort, DeviceMode);
// Pega um ponteiro para DEVMODE
M := GlobalLock(DeviceMode);
try
if M <> nil then
begin
// Muda tamanho do papel
M^.dmFields := DM_PAPERSIZE;
if PaperSize = DMPAPER_USER then
M^.dmFields := M^.dmFields or DM_PAPERLENGTH or DM_PAPERWIDTH;
M^.dmPaperLength := Alt;
M^.dmPaperWidth := Comp;
M^.dmPaperSize := PaperSize;//
// Atualiza
Printer.SetPrinter(ADevice, ADriver, APort, DeviceMode);
end;
finally
GlobalUnlock(DeviceMode);
end;
end;


Procedure SetaTamPapel(mLength, mWidth, mPaper : integer);
var
ADevice, ADriver, APort: array[0..255] of char;
DeviceMode: THandle;
M: PDevMode;
s : string;
begin
S := Printer.Printers[Printer.PrinterIndex];
Printer.GetPrinter(ADevice, ADriver, APort, DeviceMode);
M := GlobalLock(DeviceMode);
if M <> nil then
begin
// M^.dmFields := M^.dmFields or DM_PAPERSIZE;
// M^.dmPaperSize := DMPAPER_LETTER;
M^.dmPaperSize := mPaper;
M^.dmFields := M^.dmFields or DM_PAPERLength;
M^.dmPaperLength := mLength;
M^.dmFields := M^.dmFields or DM_PAPERWidth;
M^.dmPaperWidth := mWidth;
Printer.SetPrinter(ADevice, ADriver, APort, DeviceMode);
end;
end;


procedure TFRFSaldo.BitBtn2Click(Sender: TObject);
begin
Close;
end;

procedure TFRFSaldo.BitBtn1Click(Sender: TObject);
begin
//MudaTamPapel(DMPAPER_USER, 870, 500);
SetPrinterPage(870,500);

if dataI.Date <= DataF.Date then
begin
query1.close;
query1.prepare;
query1.ParamByName('datai').AsDate := DataI.Date;
query1.ParamByName('dataf').AsDateTime := DataF.Date;
Query1.Open;
FRSaldo.di.caption := DateToStr(datai.date);
FRSaldo.df.caption := DateToStr(dataf.date);
FRSaldo.QuickRep1.Preview;
end else ShowMessage('Data Final menor que Data Inicial');
end;

procedure TFRFSaldo.FormShow(Sender: TObject);
begin
datai.date := date;
dataf.date := date;
end;

end.
