unit u_cRankingClientes;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, DBTables, ComCtrls, Grids, DBGrids, StdCtrls, Buttons;

type
  TFCRankingClientes = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    BitBtn1: TBitBtn;
    DBGrid2: TDBGrid;
    datai: TDateTimePicker;
    dataf: TDateTimePicker;
    BitBtn2: TBitBtn;
    Query1: TQuery;
    DataSource1: TDataSource;
    Table1: TTable;
    DataSource2: TDataSource;
    Table1Registro: TAutoIncField;
    Table1CliCodigo: TIntegerField;
    Table1Qtde: TIntegerField;
    Table1CliNome: TStringField;
    Query1LCliente: TIntegerField;
    Query1LDataLocacao: TDateField;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FCRankingClientes: TFCRankingClientes;

implementation

uses u_DM;

{$R *.dfm}

procedure TFCRankingClientes.BitBtn1Click(Sender: TObject);
var qtde : integer;
begin

// zerando temporario

if Table1.RecordCount > 0  then
begin
   Table1.Last;
   while not Table1.Bof do Table1.Delete;
end;

if DataI.Date <= DataF.Date then
begin
// filtrando periodo
DataModule1.TLancamento.Filtered := False;
DataModule1.TLancamento.Filter := 'LDataLocacao >= ' + '''' +
 DatetoStr(DataI.date) + '''' + ' and LDataLocacao<= ' + '''' +
   DateToStr(DataF.Date) + '''';
DataModule1.TLancamento.Filtered := True;



//abrindo consulta sobre periodo
Query1.Close;
query1.ParamByName('di').AsDate := DataI.Date;
query1.ParamByName('df').AsDate := Dataf.Date;
Query1.Open;

Query1.First;
while not Query1.eof do
begin
 qtde := 0;
 DataModule1.TLancamento.First;
 while not DataModule1.TLancamento.eof do
 begin
   if Query1.FieldByName('LCliente').AsInteger = DataModule1.TLancamento.FieldByName('LCliente').AsInteger then
     qtde := qtde + 1;
   DataModule1.TLancamento.Next;
 end;

//gravando temporario
Table1.IndexName := 'CliCodigo';
if not Table1.FindKey([Query1.FieldByName('LCliente').AsInteger]) then
begin
Table1.Insert;
Table1.FieldByName('CliCodigo').AsInteger := Query1.FieldByName('LCliente').AsInteger;
Table1.FieldByName('Qtde').AsInteger := qtde;
Table1.Post;
end;

Query1.Next;
end;
end else ShowMessage('Data Final menor que Data Inicial !');
Table1.IndexName := 'Quantidade';
Table1.First;
end;

procedure TFCRankingClientes.FormShow(Sender: TObject);
begin
datai.date := date;
dataf.date := date;
if Table1.RecordCount > 0  then
begin
   Table1.Last;
   while not Table1.Bof do Table1.Delete;
end;

end;

procedure TFCRankingClientes.FormClose(Sender: TObject; var Action: TCloseAction);
begin
DataModule1.TLancamento.Filtered := False;
DataModule1.TLancamento.Filter :='';
end;

procedure TFCRankingClientes.BitBtn2Click(Sender: TObject);
begin
close;
end;

end.
